unit MoveUtil;

//^Ɋւ邨֗[`W

interface

uses
  SysUtils,dddd,defs,classes,Windows,s_MathPack;


//ꎟ̐
function MvBreaking(t:Integer; b:Integer):Integer;    //t0ɁAb߂Â
function MvLimitation(t:Integer; l:Integer):Integer;  //t̐Βllȓɂ
function MvRandom(width:Integer):Integer;             //}width͈̔͂ŗ𔭐

//ϊ
function MvVelToRot(dx,dy:Single):Integer;            //ړʂ킷XvCgԍԂ
function MvRegulateRect(r:TRect):TRect;               //`𓖂蔻Ŏg悤ɐK

//񎟌̉^
function MvNormalize(p:TVector2D; k:Single):TVector2D;         //Vector2D̒k
function MvTargetting(p,target:TVector2D; k:Single):TVector2D; //kpn_Ƃtargetɋ߂Â
function MvLimitation2D(p:TVector2D; k:Single):TVector2D;      //p̑kȓɂ

//]
function MvRandomRot(p:TVector2D; t:Integer; k:Single):TVector2D; //pɑ΂āA}tx͈̔͂Ń_BApkɐKς݂Ɖߒ
function MvRot(p:TVector2D; t:Integer; k:Single):TVector2D; //pɑ΂āAvXtx]BApkɐKς݂Ɖߒ

//
//XvC
function MvInterpolate(p:Array of TVector2D; t,tmax:Single):TVector2D;

implementation


function MvBreaking(t:Integer; b:Integer):Integer;  //t0ɁAb߂Â
begin
  if t < 0 then
    result:=t + b
  else if t> 0 then
    result:=t - b
  else
    result:=0;
end;


function MvLimitation(t:Integer; l:Integer):Integer;
begin
  if l<0 then
    l:=-l;

  if t<0 then begin
    if -t > l then
      result:=-l
    else
      result:=t;
  end else begin
    if t > l then
      result:=l
    else
      result:=t;
  end;

end;


//}width͈̔͂ŗ𔭐
function MvRandom(width:Integer):Integer;
begin
  result:=Random(width Shl 1 + 1)  - width;
end;


//ړʂ킷XvCgԍԂ
function MvVelToRot(dx,dy:Single):Integer;
var
	rad:Single;
  deg:Integer;
begin

  //Ƃ肠A1024xnŊpxo
  if dx <> 0 then begin
    rad := ArcTan(-dy/dx);
    deg := Round(rad * 512.0 / Pi);

    if dx < 0 then
      Inc(deg,512)
    else if dy > 0 then
      Inc(deg,1024);

  end else begin
    if dy < 0 then
      deg:=256
    else
      deg:=768;
  end;

	deg:=1024-deg;
	Dec(deg,256);
	deg:=deg And 1023 Shr 7;

  result:=deg;
end;

//`𓖂蔻Ŏg悤ɐK
function MvRegulateRect(r:TRect):TRect;
begin
  if r.left > r.right then begin
    result.left:=r.right;
    result.right:=r.left;
  end else begin
    result.left:=r.left;
    result.right:=r.right;
  end;

  if r.top > r.bottom then begin
    result.top:=r.bottom;
    result.bottom:=r.top;
  end else begin
    result.top:=r.top;
    result.bottom:=r.bottom;
  end;
end;


//Vector2D̒k
function MvNormalize(p:TVector2D; k:Single):TVector2D;
var
  size,factor:Single;
  function _sqr(x:Single):Single;
  begin
    result:=x*x;
  end;
begin

  size:=_sqr(p.x) + _sqr(p.y);

  //̃TCY]ɂȂAKȒlԂB
  if size < 0.00001 then begin
    result.x:=k;
    result.y:=0;
    exit;
  end;
  factor:=sqrt(_sqr(k) / size);

  result.x:=p.x * factor;
  result.y:=p.y * factor;
end;


//kpn_Ƃtargetɋ߂Â
function MvTargetting(p,target:TVector2D; k:Single):TVector2D;
var
  size,factor:Single;
  v:TVector2D;
  function _sqr(x:Single):Single;
  begin
    result:=x*x;
  end;
begin
  v.x:=target.x - p.x;
  v.y:=target.y - p.y;

  //̌vZ
  size:=_sqr(v.x) + _sqr(v.y);

  //k菬ȂÂ܂
  if size < _sqr(k) then begin
    result:=v;
    exit;
  end;

  //낦B
  factor:=sqrt(_sqr(k) / size);

  result.x:=v.x * factor;
  result.y:=v.y * factor;
end;


//pɑ΂āA}tx(1024xn)͈̔͂Ń_BApkɐKς݂Ɖ
function MvRandomRot(p:TVector2D; t:Integer; k:Single):TVector2D;
var
  ca,sa:Single;
  rad:Integer;
begin
  ca:=p.X / k;
  sa:=p.Y / k;

  rad:=(Random(2*t)-t) And 1023;

  result.X:=k * (ca * FCosT[rad] - sa * FSinT[rad]);
  result.Y:=k * (sa * FCosT[rad] + ca * FSinT[rad]);
end;


//p΂āAtx]BApkɐKς݂Ɖ
function MvRot(p:TVector2D; t:Integer; k:Single):TVector2D;
var
  ca,sa:Single;
begin
  ca:=p.X / k;
  sa:=p.Y / k;

  result.X:=k * (ca * FCosT[t And 1023] - sa * FSinT[t And 1023]);
  result.Y:=k * (sa * FCosT[t And 1023] + ca * FSinT[t And 1023]);
end;


//p̑kȓɂ
function MvLimitation2D(p:TVector2D; k:Single):TVector2D;
var
  size,factor:Single;
  function _sqr(x:Single):Single;
  begin
    result:=x*x;
  end;
begin
  //̌vZ
  size:=_sqr(p.x) + _sqr(p.y);

  //k菬ȂÂ܂
  if size < _sqr(k) then begin
    result:=p;
    exit;
  end;

  //낦B
  factor:=sqrt(_sqr(k) / size);

  result.x:=p.x * factor;
  result.y:=p.y * factor;
end;


//XvC
//pŗ^_nɓԊuɕсAtmax܂őf[^Ƃ݂ȂAtɂf[^o
function MvInterpolate(p:Array of TVector2D; t,tmax:Single):TVector2D;
var
  s:Array[0..3] of TVector2D;
  ks:Array[0..3] of Single;
  base:Integer; //s[0]p[base]ɓB
  tick:Single;
  k,ki,k2,k3:Single;
  i:Integer;
begin

  tick:=tmax/(High(p));
  base:=Trunc(t/ (tick))-1;

  //if base > High(p)-2 then
  //  base:=high(p)-2;

  for i:=0 to 3 do begin
    if base+i < 0 then
      s[i]:=p[0]
    else if base+i > high(p) then
      s[i]:=p[high(p)]
    else
      s[i]:=p[base+i];
  end;


  k:=(t - (tick * (base+1))) / tick;

  if k < 0.0 then
    k:=k+1.0;

  ki:=1.0-k;
  k2:=k*k;
  k3:=k2*k;

  {
  ks[0]:=k1*k1*k*3;
  ks[1]:=k1*k1*k1;
  ks[2]:=k*k*k;
  ks[3]:=k1*k*k*3;
  }

  ks[0]:=ki*ki*ki*0.16;
  ks[1]:=k3*0.5 - k2 + 0.667;
  ks[2]:=(-k3 + k2 + k)*0.5 + 0.167;
  ks[3]:=k3*0.167;

    result.x:=s[0].x * ks[0] +  s[1].x * ks[1] +  s[2].x * ks[2] +  s[3].x * ks[3];
  result.y:=s[0].y * ks[0] +  s[1].y * ks[1] +  s[2].y * ks[2] +  s[3].y * ks[3];

end;


//xɉĒe`FbN
function MvCanShoot(t:Integer):Boolean;
begin
  if GAMELEVEL = 0 then begin
    result:=False;
    Exit;
  end;

  Result:= Random(t div GAMELEVEL) = 0; 
end;

end.
