unit Stars;

//wi`惆jbg

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  d3d, d3dtypes, d3dcaps,
  DDSD, dddd, ddddut, defs, ddraw, primitives, s_mathpack, dddd3dut;

//
type TStars = class
  private
    Dy:PIntArray;   //̃Xs[h
    XStar,YStar,AnimStar:PIntArray;

    DyDust,XDust,YDust,ColDust:PIntArray; //p
    ColorTbl:Array[0..15] of DWord; //̖ŗp

    Ani:Integer;  //Aj[V̑xpJE^
    FScrWidth,FScrHeight:Integer;
    FDD:TDDDD;
    FNumStar:Integer;
    FNumDust:Integer; //
    //suStar:TDDDDSurface;
    //spStar:TDDDDSprite;
    //ShapePos:TPoint;  //̊GۑĂAEʒu
    TexStar:TDDDDTexture;
    Rend:TPrimitiveRenderer;
  public
    constructor Create(DDCompo:TDDDD; numStar, ScrWidth,ScrHeight:Integer; Tex:TDDDDTexture);
    destructor Destroy; override;
    procedure Restore(Tex:TDDDDTexture);
    procedure Update(t:Integer);
end;


//zɂwic\ʑ̂ɁAeNX`\ĂƂĕ\
type TBGSphere = class
  private
    Tex:TDDDDTexture;             //wiɎgeNX`
    AgeT:Integer;                 //
    Sphere:Array[0..19,0..2] of D3DVECTOR;    //z̊eʂɂĂ̒_f[^
    TexCoord:Array[0..19,0..2] of TVector2D;  //eNX`W
  public
    constructor Create(texture:TDDDDTexture);
    procedure Update(t:Integer);
end;



implementation

constructor TStars.Create(DDCompo:TDDDD; numStar, ScrWidth,ScrHeight:Integer; Tex:TDDDDTexture);
var
  i:Integer;
begin
  FDD:=DDCompo;
  GetMem(Dy,numStar*Sizeof(Integer));
  FScrWidth:=ScrWidth;
  FScrHeight:=ScrHeight;
  FNumStar:=numStar;

  FNumDust:=1024;
  GetMem(DyDust,FNumDust*Sizeof(Integer));
  GetMem(XDust,FNumDust*Sizeof(Integer));
  GetMem(YDust,FNumDust*Sizeof(Integer));
  GetMem(ColDust,FNumDust*Sizeof(Integer));
  GetMem(XStar,FNumStar*Sizeof(Integer));
  GetMem(YStar,FNumStar*Sizeof(Integer));
  GetMem(AnimStar,FNumStar*Sizeof(Integer));

  For i:=0 to 7 do begin
    //ColorTbl[i  ]:=FDD.RGBToDWord(i*16+64,i*16+64,i*16+64);
    //ColorTbl[i+8]:=FDD.RGBToDWord(192-i*16,192-i*16,192-i*16);
    ColorTbl[i  ]:=FDD.ARGBToPhysical(255, i*16+32,i*16+32,i*16+32);
    ColorTbl[i+8]:=FDD.ARGBToPhysical(255, 160-i*16,160-i*16,160-i*16);
  end;



  //pXvCgnumStar܂œɕ\AVFCv9
  Rend:=TPrimitiveRenderer.Create(QD,numStar,9);
  //spStar:=TDDDDSprite.Create(numStar,9);

  //T[tFXEXvCgVFCvݒ
  //ShapePos:=p;
  Restore(Tex);

  //T[tFXݒ
  //suStar:=Surf;
  TexStar:=Tex;

  {
  For i:=0 to FNumStar-1 do begin
    with spStar[i] do begin
      iShape:=Random(3)*3;
      MinAnim:=0;
      MaxAnim:=+2;
      iAnim:=Random(3);
      RewindAnim:=True;
      X:=Random(FScrWidth);
      Y:=Random(FScrHeight);
      Visible:=True;
      Dy^[i]:=Random(8)+2;
    end;
  end;
  }
  For i:=0 to FNumStar-1 do begin
    XStar^[i]:=Random(FScrWidth);
    YStar^[i]:=Random(FScrHeight);
    Dy^[i]:=Random(6)+4;
    AnimStar^[i]:=Random(9);
  end;


  For i:=0 to FNumDust-1 do begin
    DyDust^[i]:=Random(3)+1;
    XDust^[i]:=Random(FScrWidth);
    YDust^[i]:=Random(FScrHeight);
    ColDust^[i]:=Random(128);
  end;

  //AjJE^Zbg
  Ani:=0;

end;

destructor TStars.Destroy;
begin
  FreeMem(Dy);
  FreeMem(DyDust);
  FreeMem(XDust);
  FreeMem(YDust);
  FreeMem(ColDust);
  FreeMem(XStar);
  FreeMem(YStar);
  FreeMem(AnimStar);

  Rend.Free;
  //suStar.Free;
end;

procedure TStars.Update(t:Integer);
var
  i:Integer;
  ddsd:DDSurfaceDesc2;
begin
  //

  if FDD.BackBuffer.IsLost then
    Exit;

  FDD.BackBuffer.Lock(ddsd);
  For i:=0 to FNumDust-1 do begin

    FDD.BackBuffer.Pixels[XDust^[i],YDust^[i]]:=ColorTbl[ColDust^[i] Shr 3];

    Inc(YDust^[i],DyDust^[i]*t);
    if YDust^[i] >= FScrHeight then begin
      YDust^[i]:=0;
      DyDust^[i]:=Random(3)+1;
    end;

    ColDust^[i]:=(ColDust^[i] + 1) And 127;
  end;

  FDD.BackBuffer.Unlock;


  //
  Inc(Ani);
  For i:=0 to FNumStar-1 do begin
    Inc(YStar^[i],Dy^[i]*t);
    if YStar^[i] > FScrHeight then begin
      YStar^[i]:=0;
      Dy^[i]:=Random(6)+4;
    end;

    //Aj[VJE^̃CNg
    if Ani And 3 = 0 then begin
      if AnimStar^[i] mod 3 = 2 then
        Dec(AnimStar^[i],2)
      else
        Inc(AnimStar^[i]);
    end;

    Rend.PushPatternRect(AnimStar^[i], SingleRect(XStar^[i]-8,YStar^[i]-16,XStar^[i]+8,YStar^[i]),0, bmDecal, $FFFFFFFF);
  end;
  Rend.Render;




end;

procedure TStars.Restore(Tex:TDDDDTexture);
var
  i:Integer;
begin
  TexStar:=Tex;

  //
  For i:=0 to 8 do begin
    Rend.SetPattern(i,TexStar,Rect(i*16, 0, (i+1)*16, 16));
  end;
end;







constructor TBGSphere.Create(texture:TDDDDTexture);
var
  i:Integer;
  theta:Single;
  v:Array[0..11] of D3DVector; //\ʑ̂\钸_
  r:Single;                    //\ʑ̂̃TCY
  function ACos(x:Single):Single;
  begin
    result := ArcTan (sqrt (1-x*x) /x);
  end;
begin
  //ϐ̏
  AgeT:=2000; //ƃItZbg
  Tex:=texture;

  //\ʑ̂̒_WvZ
  theta:=PI/2 - 2.0*acos( 0.5/sin(PI/5));
  r:=500;

  v[0]:=Vector(0,0,r);
  For i:=1 to 5 do begin
    v[i]:=NowScale(Vector(cos(PI*2/5*i)*cos(theta), sin(PI*2/5*i)*cos(theta), sin(theta)), r);
    v[i+5]:=NowScale(vector( cos(PI/5+PI*2/5*i)*cos(theta), sin(PI/5+PI*2/5*i)*cos(theta), -sin(theta)), r);
  end;
  v[11]:=Vector(0,0,-r);


  //ʂƒ_̑Ήt
  For i:=0 to 4 do begin
    Sphere[i,0]:=v[0];
    Sphere[i,2]:=v[i+1];
    Sphere[i,1]:=v[(i+1) mod 5 + 1];
    TexCoord[i,0]:=Vector2D(0.5, 0.0);
    TexCoord[i,2]:=Vector2D(i/5, 1/3);
    TexCoord[i,1]:=Vector2D((i+1)/5, 1/3);
  end;
  For i:=0 to 4 do begin
    Sphere[i+5,0]:=v[i+1];
    Sphere[i+5,2]:=v[i+6];
    Sphere[i+5,1]:=v[(i+1) mod 5 + 1];
    TexCoord[i+5,0]:=Vector2D(i/5, 1/3);
    TexCoord[i+5,2]:=Vector2D(i/5+0.1, 2/3);
    TexCoord[i+5,1]:=Vector2D((i+1)/5, 1/3);
  end;
  For i:=0 to 4 do begin
    Sphere[i+10,0]:=v[(i+1) mod 5 + 1];
    Sphere[i+10,2]:=v[i+6];
    Sphere[i+10,1]:=v[(i+1) mod 5 + 6];
    TexCoord[i+10,0]:=Vector2D((i+1)/5, 1/3);
    TexCoord[i+10,2]:=Vector2D(i/5+0.1, 2/3);
    TexCoord[i+10,1]:=Vector2D((i+1)/5+0.1, 2/3);
  end;
  For i:=0 to 4 do begin
    Sphere[i+15,0]:=v[11];
    Sphere[i+15,2]:=v[(i+1) mod 5 + 6];
    Sphere[i+15,1]:=v[i+6];
    TexCoord[i+15,0]:=Vector2D(0.5, 1.0);
    TexCoord[i+15,2]:=Vector2D((i+1)/5+0.1, 2/3);
    TexCoord[i+15,1]:=Vector2D(i/5+0.1, 2/3);
  end;


end;

procedure TBGSphere.Update(t:Integer);
var
  TLVs:Array[0..19,0..2] of D3DTLVertex;
  v:D3DVector;
  i,j:Integer;
begin
  Inc(AgeT,t);

  //Sphere[] TLVs[]ɓ
  for i:=0 to 19 do begin
    for j:=0 to 2 do begin
      //]āAItZbg
      v:=NowAdd( NowRotX(NowRotY(Sphere[i,j],AgeT Shr 3),-AgeT Shr 2), Vector(320,240,0));

      TLVs[i,j]:=MakeTLV(v.x,v.y,v.z,0.01, $FFFFFFFF, 0,TexCoord[i,j].x,TexCoord[i,j].y);
    end;
  end;

  //`
  QD.D3DDevice.SetTexture(0, Tex.Surface);
  QD.D3DDevice.SetTextureStageState(0, D3DTSS_MAGFILTER, Integer(D3DTFG_LINEAR));
  QD.D3DDevice.SetTextureStageState(0, D3DTSS_MINFILTER, Integer(D3DTFG_LINEAR));

  QD.D3DDevice.SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,Integer(False));
  QD.D3DDevice.SetRenderState(D3DRENDERSTATE_ZENABLE,INteger(False));
  QD.D3DDevice.SetRenderState(D3DRENDERSTATE_DITHERENABLE,Integer(True));
  QD.D3DDevice.SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE,Integer(False));

  QD.D3DDevice.DrawPrimitive(D3DPT_TRIANGLELIST,D3DFVF_TLVERTEX,@TLVs,60, 0);



end;


end.
