//GLE䃆jbg
unit enemy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddidex, defs, shkernel, moveUtil, flare, zangai, powerItem, SE, s_MathPack,
  Primitives;


//obNt@CA
type TBackFire = class(TMover)
  private
    mySpr:Integer;  //\XvCgԍ
  public
    constructor Create(owner:TMoverList; s:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;

//URIuUQ[AUR1
type TZako1 = class(TMover)
  private
    p0:TPoint;        //ʒu
    curV:TVector2D;     //݂̑x
    mySpr:Integer;    //\XvCgԍ
    Us:Array[0..6] of TVector2D;  //tŰO
  public
    iAlgo:Integer;    //ASYԍ
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; algo:Integer; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;


//Ǝ苭UR2
type TZako2 = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    FiredR:Boolean;   //ŌɌ͉̂E̖C
    p0:TPoint;        //ʒu
  public
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;


//~TCł܂G
type TZako3 = class(TMover)
  private
    pos:TVector2D;      //݂̈ʒu
    v:TVector2D;        //x
    mySpr:Integer;    //\XvCgԍ
  public
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;


//aG
type TZako4 = class(TMover)
  private
    pos:TVector2D;      //݂̈ʒu
    state:Integer;    //o=0 ]=1 =2
    mySpr:Integer;    //\XvCgԍ
    PrevRotT:DWord;
    BackFire:TBackFire; //obNt@CA
  public
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;


//iUR
type TZako5 = class(TMover)
  private
    p0:TPoint;        //ʒu
    curV:TVector2D;     //݂̑x
    mySpr:Integer;    //\XvCgԍ
    RecentAnimT:Integer;  //OAj[Vs
    BackFire:TBackFire; //obNt@CA
  public
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;

//WOUOUR
type TZako6 = class(TTransMover)
  private
    p0:TPoint;          //ʒu
    mySpr:Integer;      //\XvCgԍ
    ShotCount:Integer;  //΂TepAJE^
  public
    Velocity:TVector2D;  //x
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;


//UR[U[
type TZako7Laser = class(TMover)
  public
    constructor Create(owner:TMoverList; p:TPoint); //p̓[Ȕ[
    procedure Move(t:Integer); override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDie; override;
end;

//[U[UR
type TZako7 = class(TTransMover)
  private
    mySpr:Integer;        //\XvCgԍ
    myLaser:TZako7Laser;  //o[U[
    ArriveT:Integer;      //\莞
  public
    Velocity:TVector2D;  //x
    constructor Create(owner:TMoverList; p,t:TPoint);  //ʒuƎˌJnʒu
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;



//z[~O[U[
type THomingLaser = class(TMover)
  private
    JointPos:Array[0..31] of TVector2D;
    Velocity:TVector2D; //x
    LastT:Integer;      //ǔI
    Color:DWord;
  public
    constructor Create(owner:TMoverList; p0,v0:TVector2D; col:DWord; targetT:Integer);  //ʒuEEFEǔ
    procedure Move(t:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;

//z[~O[U[UR
type TZako8 = class(TMover)
    mySpr:Integer;        //\XvCgԍ
    State:Integer;        //(0...o, 1...U, 2...ދp)
    NShoot:Integer;       //z[~OC
  public
    Velocity:TVector2D;  //x
    constructor Create(owner:TMoverList; p:TPoint);  //ʒu
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;



//ACeLA
type TCarrier = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; p:TPoint);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;



//G̒e
type TEnemyShot1 = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    pos:TVector2D;
    v0:TVector2D;  //ʒu,
  public
    iAlgo:Integer;    //ASYԍ
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint; v:TVector2D); //ƈʒu
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDamaged(dmg:Integer); override;
end;


//G̒eA傫Đz
type TEnemyShot2 = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    pos,v0:TVector2D;   //ʒu,
  public
    iAlgo:Integer;    //ASYԍ
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint; v:TVector2D); //ƈʒu
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDamaged(dmg:Integer); override;
end;

//~TC1
type TMissile1 = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    p0:TPoint;        //ʒu
    BackFire:TBackFire; //obNt@CA
  public
    Velocity:TVector2D;  //x
    constructor Create(owner:TMoverList; p:TPoint; v:TVector2D);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
end;



//Ή
type TFire1 = class(TMover)
  private
    mySpr:Integer;  //\XvCgԍ
    pos:TVector2D;
    v0:TVector2D;     //ʒu,
    endT:DWord;     //
  public
    iAlgo:Integer;    //ASYԍ
    Velocity:TPoint;  //x
    constructor Create(owner:TMoverList; p:TPoint; v:TVector2D; lt:Integer); //ʒuƏƎ
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
    procedure OnCrush(Target:TMover); override;
end;


implementation



////////////////////////////
// LOׂUR1
////////////////////////////
constructor TZako1.Create(owner:TMoverList; algo:Integer; p:TPoint);
begin
  inherited Create(owner);

  p0:=p;
  HP:=4;
  iAlgo:=0;
  CurV:=Vector2D(0,0);

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-24,-24,+24,+24);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_ZAKO1;
    MinAnim:=0;
    MaxAnim:=7;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  iAlgo:=algo;

  //Uӂ[߁[
  if algo = 1 then begin
    Us[0]:=Vector2D(560,500);
    Us[1]:=Vector2D(560,320);
    Us[2]:=Vector2D(440,120);
    Us[3]:=Vector2D(320, 80);
    Us[4]:=Vector2D(200,120);
    Us[5]:=Vector2D( 80,320);
    Us[6]:=Vector2D( 80,500);
    MoveTo(560,500);
  end else
    MoveTo(p.x,p.y);

end;

destructor TZako1.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako1.Move(t:Integer);
var
  dx,dy,tx,ty:Integer;
  vx,vy:Single;
  p:TVector2D;
  curX,curY:Integer;
begin
  inherited;

  Case iAlgo of
    //ASY0 TCJ[u
    0: begin
      curX:=(SinT[(ageT*6) And 1023]) div 4 + p0.x;  //U256hbgSin
      curY:=ageT*2 + p0.y;

      dx:=curX-X;
      dy:=curY-Y;

      MoveTo(curX,curY);
      FOwner.Spr[mySpr].IAnim:=MvVelToRot(dx,dy);

      if Y > 500 then begin
        Die;
      end;
    end;

    //ASY1 tU
    1: begin
      if AgeT > 120 then begin
        Die;
        Exit;
      end;
      p:=MvInterpolate(Us, AgeT, 120);
      dx:=Round(p.x) - X;
      dy:=Round(p.y) - y;
      MoveTo(Round(p.x),Round(p.y));
      FOwner.Spr[mySpr].IAnim:=MvVelToRot(dx,dy);
    end;

    //ASY2 荞
    2: begin
      if ageT > 256 then begin
        dx:=Round(curV.x);
        dy:=Round(curV.y*t);
      end else begin
        //ڕWn_EmF
        tx:=FOwner.HeroPos.X;
        ty:=FOwner.HeroPos.Y;

        Inc(tx,CosT[(ageT*6) And 1023] div 9); //@̉̂_ڕWn_
        Inc(ty,SinT[(ageT*6) And 1023] div 9);


        p:=MvTargetting(Vector2D(X,Y),Vector2D(tx,ty),2);
        CurV.x:=CurV.x + p.x;
        CurV.y:=CurV.y + p.y;
        CurV:=MvLimitation2D(CurV,6);

        dx:=Round(curV.x*t);
        dy:=Round(curV.y*t);
      end;
      MoveTo(X+dx,Y+dy);
      FOwner.Spr[mySpr].IAnim:=MvVelToRot(FOwner.HeroPos.X-X,FOwner.HeroPos.Y-Y);

      //Xeł
      if (CurV.X < 2.0) And (CurV.Y < 2.0) And CanShootConst(0,4) And (ageT > 50) then begin
        //@Ɍ
        vx:=FOwner.HeroPos.X - X;
        vy:=FOwner.HeroPos.Y - Y;

        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvNormalize(Vector2D(vx,vy),2.0)));
        if GAMELEVEL >= 1 then begin
          FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvRot(MvNormalize(Vector2D(vx,vy),6.0),40,6.0)));
          FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvRot(MvNormalize(Vector2D(vx,vy),6.0),40,6.0)));
        end;
      end;

      if (Y > 500) Or (Y < -60) Or (X > 700) Or (X<-60) then begin
        Die;
      end;
    end;

    //V^(očʂāAE)
    3:begin
      if AgeT < 75 then begin
        dx:=0;
        dy:=6 * t;
      end else begin
        dx:=4 * t;
        dy:=-4 * t;
      end;
      MoveTo(X+dx,Y+dy);
      FOwner.Spr[mySpr].IAnim:=MvVelToRot(dx,dy);
      if Y < -40 then
        Die;
    end;

    //V^(EoĉEʂāA)
    4:begin
      if AgeT < 75 then begin
        dx:=0;
        dy:=6 * t;
      end else begin
        dx:=-4 * t;
        dy:=-4 * t;
      end;
      MoveTo(X+dx,Y+dy);
      FOwner.Spr[mySpr].IAnim:=MvVelToRot(dx,dy);
      if Y < -40 then
        Die;
    end;

  end;

  //Xe
  if CanShootConst(1,GAMELEVEL * 2) then begin
    //p.X:=FOwner.HeroPos.X - X;
    //p.Y:=FOwner.HeroPos.Y - Y;
    p.X:=dx;
    p.Y:=dy;
    p:=MvNormalize(p,6);

    FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),p));
    FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvRot(p,75,6)));
    FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvRot(p,-75,6)));

  end;

  Velocity:=Point(dx div t,dy div t);
end;

procedure TZako1.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-32;
  FOwner.Spr[mySpr].Y:=yy-32;
end;

procedure TZako1.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TZako1.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_ZAKO1;

    //p[ACe悤
    //FOwner.Add(TPowerItem.Create(FOwner,1, X,Y, Vector2D(0,-5.0)));

    //Ռg
    FOwner.Add(TShockWave4.Create(FOwner,X,Y,0));
    //_łȂړ
    Fowner.Add(TBlinker.Create(FOwner,Fowner.Spr[MySpr].IShape+Fowner.Spr[MySpr].IAnim, X,Y, Velocity.X,Velocity.Y,8));
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, X+Velocity.X*8,Y+Velocity.Y*8, 12));
    FOwner.Add(TShockWave1.Create(FOwner, X+Velocity.X*8,Y+Velocity.Y*8, 20));

    //Ή(8)
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    info.x:=x;
    info.y:=y;
    info.point:=SC_ZAKO1;

    SendMessage(Parent,MSG_DESTROYED,@info);
    Die;
  end;
end;

procedure TZako1.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;


////////////////////////////
// UR2
////////////////////////////
constructor TZako2.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  HP:=24;
  p0:=p;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-46,-46,+46,+46);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako2;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p0.x,p0.y);

end;

destructor TZako2.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako2.Move(t:Integer);
var
  vx,vy:Single;
  curY:Integer;
  bx,by:Integer;
begin
  inherited;

  //iāAʂ̔肿傢̂ƂŒ~AeoTAŁA֓

  if (ageT >= 50) And (ageT <= 120) then begin
    //eł


    if CanShootConst(0, 30*GAMELEVEL+4) then begin
      //Ɍāc
      vx:=0;
      vy:=1;

      //ŌɌ̂Ƌt̖C䂩e𔭎
      by:=Y+44;
      if FiredR then
        bx:=X-44
      else
        bx:=X+44;
      FiredR:=not FiredR;
      FOwner.Add(TEnemyShot2.Create(FOwner,Point(bx,by), MvRot(MvNormalize(Vector2D(vx,vy),4.0),(AgeT*20 And 511) - 256,4.0)));
    end;
    curY:=Y;
  end else if (ageT > 40) And (AgeT < 50)  then begin
    //
    curY:=Y + Round( t * Velocity.Y * ((50-ageT) / 10.0));
  end else if (ageT > 120) And (ageT < 130) then begin
    //
    curY:=Y + Round( t * Velocity.Y * ((ageT-120) / 10.0));
  end else begin
    //
    curY:=Y + t*Velocity.Y;
  end;

  MoveTo(X,curY);

  if Y > 500 then begin
    Die;
  end;


end;

procedure TZako2.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-64;
  FOwner.Spr[mySpr].Y:=yy-64;
end;

procedure TZako2.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TZako2.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako2;

    //p[ACe悤
    //FOwner.Add(TPowerItem.Create(FOwner,2, X,Y, Vector2D(0,-5.0)));

    //ĎrEҖ
    FOwner.Add(TDyingZako2.Create(FOwner, X,Y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_ZAKO2;
    SendMessage(Parent,MSG_DESTROYED,@info);

    Die;
  end;
end;

procedure TZako2.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////
// ~TCł܂UR3
////////////////////////////
constructor TZako3.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  HP:=24;

  pos.x:=p.x;
  pos.y:=p.y;
  v:=Vector2D(0.0,2.0);

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-36,-28,+36,+24);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako3;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

end;

destructor TZako3.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako3.Move(t:Integer);
var
  p:TVector2D;
  i:Integer;
begin
  inherited;

  //iāAʂ̏ 1/4̂ƂŒ~A~TCł㏸
  if (ageT > 25) then begin
    if (AgeT > 45) then begin
      if CanShootConst(1, 8) then begin
        if ShootCount[1] <= (GAMELEVEL*4 + 3) then begin  //ƗˋC
          //~TC񔭔
          FOwner.Add(TMissile1.Create(FOwner,Point(X-24,Y+36),Vector2D(-0.5 * (ShootCount[1] And 3),+1.0 +V.Y)));
          FOwner.Add(TMissile1.Create(FOwner,Point(X+24,Y+36),Vector2D(+0.5 * (ShootCount[1] And 3),+1.0 +V.Y)));
        end;
      end;
    end;

    v.y := v.y - t * 0.1;
    if v.y < -0.5 then
      v.y := -0.5
  end else begin
    v.y:=v.y + t * 0.1;
    if v.y > 5.0 then
      v.y:=5.0;
  end;

  //e
  if CanShootConst(0, 3*GAMELEVEL) then begin
    p.X:=FOwner.HeroPos.X - X;
    p.Y:=FOwner.HeroPos.Y - Y;
    p:=MvNormalize(p,4*GAMELEVEL);

    if GAMELEVEL = 1 then begin
      if AgeT > 75 then begin
        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y+40),MvRot(p,40,4*GAMELEVEL)));
        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y+40),MvRot(p,80,4*GAMELEVEL)));
        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y+40),MvRot(p,-40,4*GAMELEVEL)));
        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y+40),MvRot(p,-80,4*GAMELEVEL)));
      end;
    end;

    if GAMELEVEL = 2 then begin
      if AgeT > 75 then begin
        For i:=0 to 6 do begin
          if i = 3 then
            Continue;
          FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y+24),MvRot(p,(i-3) * 30,4*GAMELEVEL)));
        end;
      end;
    end;
  end;

  pos.y:=pos.y + v.y * t;
  X:=Round(pos.x);
  Y:=Round(pos.y);

  MoveTo(X,Y);

  if Y < -64 then begin
    Die;
  end;

end;

procedure TZako3.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-48;
  FOwner.Spr[mySpr].Y:=yy-48;
end;

procedure TZako3.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TZako3.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako3;

    //p[ACe悤
    //FOwner.Add(TPowerItem.Create(FOwner,2, X,Y, Vector2D(0,-5.0)));

    //ĎrEҖ
    FOwner.Add(TDyingZako3.Create(FOwner, x,y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_ZAKO3;

    SendMessage(Parent,MSG_DESTROYED,@info);
    Die;
  end;
end;

procedure TZako3.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////
// aUR4
////////////////////////////
constructor TZako4.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  HP:=16;
  State:=0;
  BackFire:=Nil;

  pos.x:=p.x;
  pos.y:=p.y;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-24,-24,+24,+24);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako4;
    MinAnim:=0;
    MaxAnim:=7;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

end;

destructor TZako4.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako4.Move(t:Integer);
var
  v:TVector2D;
  i,Rot:Integer;
begin
  inherited;

  case State of
    //o
    0:begin
      //ʂ̉ڎwē[
      v:=MvTargetting(pos,Vector2D(320.0,400.0),6.0);
      Rot:=MvVelToRot(v.x,v.y);

      //q[[eoĂ邩A`FbN
      if AgeT > 15 then begin
        For i:=0 to FOwner.Count-1 do begin
          if FOwner.Movers[i].Attr = maHB then begin
            //][h
            State:=1;
            PrevRotT:=ageT;
            Rot:=0;
            break;
          end;
        end;
      end;

      //Aʉ܂łĂA][h
      if (v.x<1.0) And (v.y<1.0) then begin
        State:=1;
        PrevRotT:=ageT;
        Rot:=0;
      end;
    end;

    //ɂ邼[
    1:begin
      v:=Vector2D(0,0);
      Rot:=FOwner.Spr[mySpr].IAnim;
      //4t[45x]AĊāB
      if AgeT > PrevRotT + 3 then begin
        Inc(Rot);
        PrevRotT:=AgeT;
        if Rot = 4 then begin
          State:=2;
          //o[i[_΃b
          BackFire:=TBackFire.Create(FOwner,S_BFZAKO4);
          BackFire.MoveTo(Round(Pos.x),Round(Pos.Y)+20);
          FOwner.Add(BackFire);
        end;
      end;
    end;

    //[
    2:begin
      Rot:=4;
      v:=Vector2D(0,-8.0);
    end;
  end;

  pos.y:=pos.y + v.y * t;
  pos.x:=pos.x + v.x * t;
  X:=Round(pos.x);
  Y:=Round(pos.y);

  FOwner.Spr[mySpr].IAnim:=Rot;

  MoveTo(X,Y);

  if (Y < -32) then begin
    Die;
  end;

end;

procedure TZako4.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-32;
  FOwner.Spr[mySpr].Y:=yy-32;

  if Assigned(BackFire) then
    BackFire.MoveTo(xx,yy+20);
end;

procedure TZako4.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;

  if Assigned(BackFire) then
    BackFire.Die;
end;

procedure TZako4.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako4;

    //p[ACe悤
    //FOwner.Add(TPowerItem.Create(FOwner,1, X,Y, Vector2D(0,-5.0)));

    //Ռg
    FOwner.Add(TShockWave4.Create(FOwner,X,Y,0));
    //_łȂړ
    Fowner.Add(TBlinker.Create(FOwner,Fowner.Spr[MySpr].IShape+Fowner.Spr[MySpr].IAnim, X,Y, 0,0,8));
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, X,Y, 12));
    FOwner.Add(TShockWave1.Create(FOwner, X,Y, 20));

    //YtAƏՌg
    //FOwner.Add(TLensFlare1.Create(FOwner, X,Y, 4));
    //FOwner.Add(TShockWave1.Create(FOwner, X,Y, 12));

    //Ή8
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160,X,Y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_Zako4;

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    SendMessage(Parent,MSG_DESTROYED,@info);
    Die;
  end;
end;

procedure TZako4.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////
// iUR
////////////////////////////
constructor TZako5.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  p0:=p;
  HP:=1;
  CurV:=Vector2D(0,0);

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-10,-20,+10,+20);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako5;
    MinAnim:=0;
    MaxAnim:=7;
    iAnim:=0;
    RewindAnim:=False;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

  BackFire:=TBackFire.Create(FOwner,S_BFZAKO5);
  BackFire.MoveTo(X,Y-44);
  FOwner.Add(BackFire);
end;

destructor TZako5.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako5.Move(t:Integer);
var
  dx,dy:Integer;
  p:TVector2D;
begin
  inherited;

  dx:=Velocity.X;
  dy:=Velocity.Y*t;

  MoveTo(X+dx,Y+dy);
  if RecentAnimT < (ageT - 4) then begin
    RecentAnimT:=ageT;
    FOwner.Spr[mySpr].NextFrame;
  end;

  //X
  {
  if GAMELEVEL = 2 then begin
    if CanShootConst(0, 4) then begin
      p.X:=FOwner.HeroPos.X - X;
      p.Y:=FOwner.HeroPos.Y - Y;
      p:=MvNormalize(p,GAMELEVEL*4);
      FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),p));
    end;
  end;
  }

  if Y>500 then begin
    Die;
  end;

  BackFire.MoveTo(X,Y-44);
end;

procedure TZako5.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-24;
  FOwner.Spr[mySpr].Y:=yy-24;
end;

procedure TZako5.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
  BackFire.Die;
end;

procedure TZako5.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
  p:TVector2D;
  i:Integer;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako5;

    //p[ACe悤
    //FOwner.Add(TPowerItem.Create(FOwner,0, X,Y, Vector2D(0,-5.0)));

    //YtA
    FOwner.Add(TLensFlare2.Create(FOwner,X,Y,4,$FF80C0FF));

    info.x:=x;
    info.y:=y;
    info.point:=SC_Zako5;

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    SendMessage(Parent,MSG_DESTROYED,@info);
    FOwner.Add(TSpark2.Create(FOwner, 2, 768,160,X,Y));

    //Ԃ
    if GAMELEVEL >= 1 then begin
      p.X:=0;
      p.Y:=1.0;
      p:=MvNormalize(p,4);

      For i:=0 to 7 do begin
        //Q[x14
        if not ((GAMELEVEL = 1) And ((i And 1) = 1)) then
          FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),MvRot(p,128*i,4)));
      end;
    end;

    Die;

  end;
end;

procedure TZako5.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;



////////////////////////////
// WOUOUR
////////////////////////////
constructor TZako6.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  p0:=p;
  HP:=8;
  State:=0;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(18-32,14-32,48-32,58-32);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako6;
    MinAnim:=0;
    MaxAnim:=7;
    iAnim:=0;
    RewindAnim:=False;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  Velocity:=Vector2D(0,0);
  MoveTo(p.x,p.y);

end;

destructor TZako6.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako6.Move(t:Integer);
var
  dx,dy:Integer;
  p:TVector2D;
  //EɈړAʂ͂ݏoȂ悤
  function RandMove:Tvector2D;
  begin
    Velocity.X:= (Random(2)*2-1) * 5.0;
    Velocity.Y:=4.0;
    //ړʁA͂ݏo悤ȂUȂ
    if ((X + Velocity.X * 40) > 608) Or ((X + Velocity.X * 40) < 32) then
      Velocity.X:=-Velocity.X;
    FOwner.Spr[mySpr].IAnim:=MvVelToRot(Velocity.X,Velocity.Y);
  end;
begin
  inherited;


  Case State of
    0: begin  //o
      RandMove;
      State:=1;
      //ړ
      dx:=Round(Velocity.X*t);
      dy:=Round(Velocity.Y*t);
    end;

    1: begin  //ړ
      dx:=Round(Velocity.X*t);
      dy:=Round(Velocity.Y*t);
      if StateT > 40 then begin
        State:=2;
        ShotCount:=0;
      end;
    end;

    2: begin  //]e
      dx:=0;
      dy:=0;
      if CanShootConst(1,(GAMELEVEL+1)*4) then begin
        p:=NowRot2D(Velocity,ShotCount * 4096 div ((GAMELEVEL+1)*4) );  //ě
        FOwner.Add(TEnemyShot1.Create(FOwner,Point(X,Y),NowChangeLength2D(p,6.0))); //e
        FOwner.Spr[mySpr].IAnim:=MvVelToRot(p.x,p.y);
        Inc(ShotCount);
      end;

      if ShotCount >= (GAMELEVEL+1)*4 then begin
        RandMove;
        State:=1;
      end;
    end;

  end;

  MoveTo(X+dx,Y+dy);


  if Y>512 then begin
    Die;
  end;

end;

procedure TZako6.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-32;
  FOwner.Spr[mySpr].Y:=yy-32;
end;

procedure TZako6.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TZako6.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
  p:TVector2D;
  i:Integer;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako6;

    //Ռg
    FOwner.Add(TShockWave4.Create(FOwner,X,Y,0));
    //_łȂړ
    Fowner.Add(TBlinker.Create(FOwner,Fowner.Spr[MySpr].IShape+Fowner.Spr[MySpr].IAnim, X,Y, Round(Velocity.X),Round(Velocity.Y),8));
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, Round(X+Velocity.X*8),Round(Y+Velocity.Y*8), 12));
    FOwner.Add(TShockWave1.Create(FOwner, Round(X+Velocity.X*8),Round(Y+Velocity.Y*8), 20));

    {
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, X,Y, 4));
    FOwner.Add(TShockWave1.Create(FOwner, X,Y, 12));
    }

    //Ή(8)
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_Zako6;

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    SendMessage(Parent,MSG_DESTROYED,@info);

    Die;

  end;
end;

procedure TZako6.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////
// [UUR
////////////////////////////
constructor TZako7.Create(owner:TMoverList; p,t:TPoint);
var
  d:Single;
begin
  inherited Create(owner);

  //ϐ̏
  State:=0;
  Velocity:=NowChangeLength2D(Vector2D(t.X-p.X,t.Y-p.Y),6.0);
  HP:=12;
  myLaser:=Nil;

  //ˌʒuւ̓\莞ƁAދpJn
  NowLength2D(d,Vector2D(t.X-p.X,t.Y-p.Y));
  ArriveT:=Round(d / 6.0);

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(49-64,16-64,81-64,125-64);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako7;
    MinAnim:=0;
    iAnim:=0;
    RewindAnim:=False;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

end;

destructor TZako7.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako7.Move(t:Integer);
var
  dx,dy:Integer;
  p:TVector2D;
begin
  inherited;

  Case State of

    ///////////////////o
    0: begin
      dx:=Round(Velocity.X*t);
      dy:=Round(Velocity.Y*t);
      MoveTo(X+dx,Y+dy);
      if StateT > ArriveT then
        State:=10;
    end;

    //////////////////// [U
    10: begin //ߊJn
      FOwner.Add(TSpark3.Create(FOwner,X,Y+120-64));
      State:=11;
    end;
    11: begin //ߏI܂ő҂
      if StateT > 60 then
        State:=12;
    end;
    12: begin //ˌ
      myLaser:=TZako7Laser.Create(FOwner,Point(X,Y+120-64));
      FOwner.Add(myLaser);
      State:=13;
    end;
    13: begin //ˌI܂ő҂
      if StateT > 120 then
        State:=20;
    end;

    //////////////////// ދp
    20: begin
      Velocity:=Vector2D(0,-4.0);
      dx:=Round(Velocity.X*t);
      dy:=Round(Velocity.Y*t);
      MoveTo(X+dx,Y+dy);
      if Y < -64 then
        Die;
    end;

  end;

end;

procedure TZako7.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-64;
  FOwner.Spr[mySpr].Y:=yy-64;
end;

procedure TZako7.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;

  //o[UȂ
  if myLaser <> Nil then
    myLaser.Die;
end;

procedure TZako7.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
  p:TVector2D;
  i:Integer;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako7;

    //Ռg
    FOwner.Add(TShockWave4.Create(FOwner,X,Y,0));
    //_łȂړ
    Fowner.Add(TBlinker.Create(FOwner,Fowner.Spr[MySpr].IShape+Fowner.Spr[MySpr].IAnim, X,Y, 0,0,8));
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, X,Y, 12));
    FOwner.Add(TShockWave1.Create(FOwner, X,Y, 20));

    {
    //YtAƏՌg
    FOwner.Add(TLensFlare1.Create(FOwner, X,Y, 4));
    FOwner.Add(TShockWave1.Create(FOwner, X,Y, 12));
    }

    //Ή(8)
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_Zako7;

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    SendMessage(Parent,MSG_DESTROYED,@info);

    Die;

  end;
end;

procedure TZako7.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;






////////////////////////////
// UR7̃[U
////////////////////////////
constructor TZako7Laser.Create(owner:TMoverList; p:TPoint); //p̓[Ȕ[
begin
  Inherited Create(Owner);

  //蔻̏
  FAttr:=maEB;
  FSubAttr:=[moEnemyLaser];
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-16,0,+16,480); //ʉ܂

  //ˉ
  SG.Play(CH_ENEMY3,PR_NORMAL,SE_EnemyLaser1);

  X:=p.X;
  Y:=p.Y;
end;

procedure TZako7Laser.Move(t:Integer);
  //awidth, Fcol̃[U`
  procedure DrawLay(width:Integer; col:DWord);
  begin
    FOwner.Rend.Push2D(Nil,Vector2D(X-width,Y),Vector2D(X+width,Y),Vector2D(X-width,480),Vector2D(X+width,480),
      Z_ESHOT,
      bmAdd,
      col);
  end;

  //Zp`B͍΂ߏ45x瓖ĂƂ
  procedure DrawHexPost(radius:Single; col:DWord; angle:Integer; mode:TBlendMode);  //Oډ~̔aAFApx
  var
    lv:TVector2D; //xNg
    fv:TVector2D; //ʂ̖@xNg
    l,r:Single;   //ƉE̍W
    prod:Single;  //xNgƖʂ̖@xNg̓
    i:Integer;
  begin
    lv:=Vector2D(0,1);

    for i:=0 to 5 do begin
      //ʂ̖@Ƃ̓ς߂
      fv:=NowRot2D(Vector2D(0,-1),angle + i*4096 div 6);
      NowDotProduct2D(prod, lv,fv);

      if prod < 0 then begin
        //ʂ̉ʏł̍ƉE̍W߂
        fv:=NowScale2D(fv,radius);
        r:=NowRot2D(fv,4096 div 12).X + X;
        l:=NowRot2D(fv,- (4096 div 12)).X + X;

        FOwner.Rend.PushPattern2D(P_RIBBON,
          Vector2D(l,Y),Vector2D(r,Y),Vector2D(l,480),Vector2D(r,480),
          Z_ESHOT,
          mode,
          NowScaleColor(col, -prod));

      end;

    end;
  end;
begin
  inherited;

  //̃Of
  {
  DrawLay(6, $FFC0C0C0);
  DrawLay(7, $FF808080);
  DrawLay(8, $FF404040);

  //
  DrawLay((AgeT And 7) + 7, $FF2020C0);
  }

  //DrawHexPost(8,$FF808080, AgeT*64, bmDecal);
  //DrawHexPost(8,$80FF4040,-AgeT*57, bmAlpha);
  DrawHexPost(2 + Random(6),$FF4080FF,0, bmAdd);
  DrawHexPost(2 + Random(8),$FF4080FF,0, bmAdd);
  DrawHexPost(7 + Random(16),$FF4080FF,0, bmAdd);

  if AgeT > 120 then
    Die;
end;


procedure TZako7Laser.OnCrush(Target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;




procedure TZako7Laser.OnDie;
begin
  inherited;

  //SG.Stop(CH_ENEMY3);
end;





////////////////////////////////
//z[~O[U@UR
////////////////////////////////

constructor TZako8.Create(owner:TMoverList; p:TPoint);
var
  d:Single;
begin
  inherited Create(owner);

  //ϐ̏
  State:=0;
  NShoot:=0;
  HP:=36;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=4;
  FTouchRect[0]:=Bounds(23-64,20-64,20,32);
  FTouchRect[1]:=Bounds(86-64,20-64,20,32);
  FTouchRect[2]:=Bounds(10-64,53-64,110,40);
  FTouchRect[3]:=Bounds(44-64,36-64,41,17);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Zako8;
    MinAnim:=0;
    iAnim:=0;
    RewindAnim:=False;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

end;

destructor TZako8.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TZako8.Move(t:Integer);
var
  dx,dy:Integer;
  p:TVector2D;
begin
  inherited;

  Case State of
    0: begin  //o
      Y:=Y + 4*t; //ɓ
      if AgeT > 40 then
        State:=1;
    end;

    1: begin  //ˌ
      if CanShootConst(0,4+4*GAMELEVEL) then begin
        if (NShoot And 1) = 0 then
          FOwner.Add(THomingLaser.Create(FOwner, Vector2D(X-33,Y-50),Vector2D(-6,-6),$FFFF8080,30))
        else
          FOwner.Add(THomingLaser.Create(FOwner, Vector2D(X+33,Y-50),Vector2D(+6,-6),$FFFF8080,30));

        Inc(NShoot);
      end;

      if NShoot >= (GAMELEVEL+1)*2 then
        Inc(State);
    end;

    2: begin  //Ƒ҂
      if CanShootConst(0,1) then begin
        Inc(State);
        NShoot:=0;
      end;
    end;

    3: begin //ˌ(ʏe)
      if CanShootConst(0,60) then begin
        FOwner.Add(TEnemyShot2.Create(FOwner, Point(X-32,35+Y), Vector2D(0,NShoot+4)));
        FOwner.Add(TEnemyShot2.Create(FOwner, Point(X+30,35+Y), Vector2D(0,NShoot+4)));
        if GAMELEVEL = 2 then begin
          FOwner.Add(TEnemyShot2.Create(FOwner, Point(X-32,35+Y), NowRot2D(Vector2D(0,NShoot+4),160)));
          FOwner.Add(TEnemyShot2.Create(FOwner, Point(X+30,35+Y), NowRot2D(Vector2D(0,NShoot+4),160)));
          FOwner.Add(TEnemyShot2.Create(FOwner, Point(X-32,35+Y), NowRot2D(Vector2D(0,NShoot+4),-160)));
          FOwner.Add(TEnemyShot2.Create(FOwner, Point(X+30,35+Y), NowRot2D(Vector2D(0,NShoot+4),-160)));
        end;

        Inc(NShoot);
      end;

      if NShoot >= GAMELEVEL*6 then
        Inc(State);
    end;

    4: begin  //Ƒ҂
      if CanShootConst(0,1) then begin
        Inc(State);
      end;
    end;

    5: begin  //ދp
      Y:=Y + 4*t; //ɓ
      if Y > 480+64 then
        Die;
    end;

  end;

  MoveTo(X,Y);

end;

procedure TZako8.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-64;
  FOwner.Spr[mySpr].Y:=yy-64;
end;

procedure TZako8.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;

end;

procedure TZako8.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
  p:TVector2D;
  i:Integer;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Zako8;

    //Ή(8)
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));

    //Ռg
    FOwner.Add(TLensFlare1.Create(FOwner,X,Y,0));


    //p^[
    FOwner.Add(TDyingZako8.Create(FOwner,X,Y));

    info.x:=x;
    info.y:=y;
    info.point:=SC_Zako8;

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    SendMessage(Parent,MSG_DESTROYED,@info);

    Die;

  end;
end;

procedure TZako8.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////////
// z[~OC
////////////////////////////////

//ʒuEEFEǔ
constructor THomingLaser.Create(owner:TMoverList; p0,v0:TVector2D; col:DWord; targetT:Integer);
var
  i:Integer;
begin
  inherited Create(owner);

  //ϐ̏
  Velocity:=v0;
  Color:=col;
  LastT:=targetT;

  For i:=0 to High(JointPos) do begin
    JointPos[i]:=p0;
  end;

  X:=Round(p0.X);
  Y:=Round(p0.Y);

  //ʉ
  SG.Play(CH_ENEMY1,PR_NORMAL,SE_HomingLaser);

  //蔻̏
  FAttr:=maEB;
  FSubAttr:=[moEnemyLaser];
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-6,-6,+6,+6);
end;



procedure THomingLaser.Move(t:Integer);
var
  i,j:Integer;
  target:TVector2D;
  v:Single;
  tmp:TVector2D;
  tie:Array[0..1] of TVector2D; //ӃxNg
begin
  inherited;

  //[ړ
  JointPos[0]:=NowAdd2D(JointPos[0],NowScale2D(Velocity,t));
  X:=Round(JointPos[0].X);
  Y:=Round(JointPos[0].Y);

  //ۂ
  For j:=0 to t-1 do begin
    For i:=High(JointPos) downto 1 do begin
      JointPos[i]:=JointPos[i-1];
    end;
  end;

  //
  if AgeT < LastT then begin
    target:=Vector2D(FOwner.HeroPos.X,FOwner.HeroPos.y);
    Velocity:=NowAdd2D( NowScale2D(Velocity,0.8), NowChangeLength2D(NowSub2D(target,JointPos[0]),1) );

    //ŏ͑x4
    Velocity:=NowChangeLength2D(Velocity,4);
    //Velocity:=NowChangeLength2D(NowSub2D(target,JointPos[0]),6.0);
  end else begin
    Velocity:=NowChangeLength2D(Velocity,12.0);
  end;


  //`
  For i:=0 to High(JointPos)-1 do begin

    //z[~OC̕Ӂc̊֐ߓ_ƌ݂̊֐ߓ_ŕ\ƐȁA12(6)̐
    tmp:=NowSub2D(JointPos[i+1],JointPos[i]);
    if (tmp.X = 0) And (tmp.Y = 0) And (i <> 0) then
      tie[0]:=tie[1]
    else
      tie[0]:=NowChangeLength2D(Vector2D(-tmp.Y,tmp.X),6.0);

    if i<>High(JointPos)-1 then begin
      tmp:=NowSub2D(JointPos[i+2],JointPos[i+1]);
      if (tmp.X = 0) And (tmp.Y = 0) And (i <> 0) then
        tie[1]:=tie[0]
      else
        tie[1]:=NowChangeLength2D(Vector2D(-tmp.Y,tmp.X),6.0);
    end;





    //ofs:=NowSub2D(JointPos[i+1],JointPos[i]);
    //ofs:=NowChangeLength2D(Vector2D(-ofs.Y,ofs.X),6.0);


    FOwner.Rend.PushPattern2D(P_RIBBON,

                                NowSub2D(JointPos[i+1],tie[1]),
                                NowAdd2D(JointPos[i+1],tie[1]),
                                NowSub2D(JointPos[i],tie[0]),
                                NowAdd2D(JointPos[i],tie[0])
                              ,
                              Z_ESHOT,
                              bmAdd,
                              NowScaleColor(Color,1.4-i/High(JointPos)))
    {
    FOwner.Rend.PushPattern2D(P_RIBBON,
                              [
                                NowSub2D(JointPos[i+1],ofs),
                                NowAdd2D(JointPos[i+1],ofs),
                                NowSub2D(JointPos[i],ofs),
                                NowAdd2D(JointPos[i],ofs)
                              ],
                              Z_ESHOT,
                              bmAdd,
                              NowScaleColor(Color,1.4-i/High(JointPos)))
    }


    //FOwner.Rend.PushPattern2D(P_THUNDER,[Vector2D(0,0),Vector2D(32,0),Vector2D(0,128),Vector2D(32,128)],Z_FLARE,bmAdd,$FFFFFFFF);
  end;


  //S݂͂ĂA
  For i:=0 to High(JointPos)-1 do
    if not ((JointPos[i].X < -32) Or (JointPos[i].X > 672) Or (JointPos[i].Y < -32) Or (JointPos[i].Y > 512)) then
      exit;

  Die;

end;

procedure THomingLaser.OnCrush(Target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;



////////////////////////////
// ACeLA
////////////////////////////
constructor TCarrier.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  p0:=p;
  HP:=1;

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-25,-30,+25,+30);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Carrier;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);
end;

destructor TCarrier.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TCarrier.Move(t:Integer);
var
  dx,dy:Integer;
begin
  inherited;


  //ZANAC̃ACeLAƓ
  if AgeT < 180 then begin
    //܂A蒼iĂB
    dx:=0;
    dy:=2;
  end else if AgeT < 480 then begin
    //ɁA΂炭┑
    dx:=0;
    dy:=0;
  end else begin
    //܋AB
    dx:=0;
    dy:=-6;
  end;

  MoveTo(X+dx*t,Y+dy*t);

  if Y < -60 then begin
    Die;
  end;
end;

procedure TCarrier.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-40;
  FOwner.Spr[mySpr].Y:=yy-40;
end;

procedure TCarrier.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TCarrier.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Carrier;

    //p[ACe悤
    FOwner.Add(TPowerItem.Create(FOwner,2, X,Y, Vector2D(0,-5.0)));

    //ڂ
    FOwner.Add(TFlare1.Create(FOwner,X,Y,0));
    FOwner.Add(TSpark2.Create(FOwner, 12, 768,160,X,Y));

    //ʉ
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_Shootdown1);

    info.x:=x;
    info.y:=y;
    info.point:=SC_Carrier;

    SendMessage(Parent,MSG_DESTROYED,@info);
    Die;

  end;
end;

procedure TCarrier.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;





////////////////////////////
// Ge 1
////////////////////////////
constructor TEnemyShot1.Create(owner:TMoverList; p:TPoint; v:TVector2D);
begin
  inherited Create(owner);

  pos:=Vector2D(p.x,p.y);
  v0:=v;

  //蔻̏
  FAttr:=maEB;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-1,-1,+1,+1);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_ETAMA1;
    MinAnim:=0;
    MaxAnim:=3;
    iAnim:=0;
    Visible:=True;
    Z:=Z_ESHOT;
  end;

  MoveTo(Round(pos.x),Round(pos.y));

end;

destructor TEnemyShot1.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TEnemyShot1.Move(t:Integer);
begin
  inherited;

  pos.X:=pos.x + v0.X*t;
  pos.Y:=pos.Y + v0.Y*t;

  MoveTo(Round(pos.X),Round(pos.Y));

  if CanShootConst(0, 15) then
    FOwner.Spr[mySpr].NextFrame;

  if (Y > 500) Or (Y < -20) Or (X > 700) Or (X<-60) then begin
    Die;
  end;

  {
  //_悤
  FOwner.Score:=FOwner.Score + SC_EB1 * t;
  }
end;

procedure TEnemyShot1.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-8;
  FOwner.Spr[mySpr].Y:=yy-8;
end;

procedure TEnemyShot1.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TEnemyShot1.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);

end;


procedure TEnemyShot1.OnDamaged(dmg:Integer);
begin
  inherited;

  Die;
end;

////////////////////////////
// Ge 2
////////////////////////////
constructor TEnemyShot2.Create(owner:TMoverList; p:TPoint; v:TVector2D);
begin
  inherited Create(owner);

  pos:=Vector2D(p.x,p.y);
  v0:=v;

  Velocity:=Point(0,4);

  //蔻̏
  FAttr:=maEB;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-2,-2,+2,+2);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_ETAMA2;
    MinAnim:=0;
    MaxAnim:=1;
    iAnim:=0;
    Visible:=True;
    Z:=Z_ESHOT;
  end;

  MoveTo(Round(pos.x),Round(pos.y));

end;

destructor TEnemyShot2.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TEnemyShot2.Move(t:Integer);
begin
  inherited;

  pos.X:=pos.x + v0.X*t;
  pos.Y:=pos.Y + v0.Y*t;

  MoveTo(Round(pos.X),Round(pos.Y));

  FOwner.Spr[mySpr].IAnim:=1-FOwner.Spr[mySpr].IAnim;
  if (Y > 500) Or (Y < -20) Or (X > 700) Or (X<-60) then begin
    Die;
  end;

end;

procedure TEnemyShot2.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-8;
  FOwner.Spr[mySpr].Y:=yy-8;
end;

procedure TEnemyShot2.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TEnemyShot2.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;

procedure TEnemyShot2.OnDamaged(dmg:Integer);
begin
  inherited;

  Die;
end;


////////////////////////////
// Ή
////////////////////////////
constructor TFire1.Create(owner:TMoverList; p:TPoint; v:TVector2D; lt:Integer);
begin
  inherited Create(owner);

  EndT:=lt;
  pos:=Vector2D(p.x,p.y);
  v0:=v;

  //蔻̏
  FAttr:=maEB;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-12,-12,+12,+12);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_FIRE1;
    MinAnim:=0;
    MaxAnim:=3;
    iAnim:=0;
    Visible:=True;
    Z:=Z_ESHOT;
  end;

  MoveTo(Round(pos.x),Round(pos.y));

end;

destructor TFire1.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TFire1.Move(t:Integer);
begin
  inherited;

  if AgeT > EndT then
    Die;

  pos.X:=pos.x + v0.X*t;
  pos.Y:=pos.Y + v0.Y*t;

  MoveTo(Round(pos.X),Round(pos.Y));

  FOwner.Spr[mySpr].IAnim:= AgeT Shl 2 div EndT;
  if FOwner.Spr[mySpr].IAnim > 3 then
    FOwner.Spr[mySpr].IAnim := 3;
  if (Y > 520) Or (Y < -40) Or (X > 700) Or (X<-60) then begin
    Die;
  end;

  {
  //_悤
  FOwner.Score:=FOwner.Score + SC_EB1 * t;
  }
end;

procedure TFire1.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-32;
  FOwner.Spr[mySpr].Y:=yy-32;
end;

procedure TFire1.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;

procedure TFire1.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;



////////////////////////////
// ~TC1
////////////////////////////
constructor TMissile1.Create(owner:TMoverList; p:TPoint; v:TVector2D);
begin
  inherited Create(owner);

  p0:=p;
  Velocity:=v;
  HP:=3;
  FSubAttr:=[moNoSpark];

  //蔻̏
  FAttr:=maEnemy;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-4,-12,+4,+12);

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_Missile1;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(p.x,p.y);

  BackFire:=Nil;
end;

destructor TMissile1.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TMissile1.Move(t:Integer);
var
  dx,dy:Integer;
begin
  inherited;


  if AgeT < 30 then begin
    //ŏ͏̂܂
    dx:=Round(Velocity.X*t);
    dy:=Round(Velocity.Y*t);
  end else begin
    //obNt@CA̐
    if BackFire = Nil then begin
      BackFire:=TBackFire.Create(FOwner, S_BFZAKO5);
      FOwner.Add(BackFire);
    end;

    //lɉ킹悤ɓB
    if (X > FOwner.HeroPos.X) then
      if Velocity.X < 0.0 then
        Velocity.X:=Velocity.X - 0.3
      else
        Velocity.X:=Velocity.X - 0.1
    else
      if Velocity.X > 0.0 then
        Velocity.X:=Velocity.X + 0.3
      else
        Velocity.X:=Velocity.X + 0.1;


    //cɉ
    Velocity.Y:=Velocity.Y + 1.0;

    if Velocity.X > 3.0 then
      Velocity.X:=3.0
    else if Velocity.X < -3.0 then
      Velocity.X:=-3.0;

    if Velocity.Y > 12.0 then
      Velocity.Y:=12.0;

    dx:=Round(Velocity.X*t);
    dy:=Round(Velocity.Y*t);

    //u
    if CanShootConst(0,30) then begin
      FOwner.Add(TMissile1Smoke.Create(FOwner, X, Y-24));
      FOwner.Add(TMissile1Smoke.Create(FOwner, X, Y-8));
    end;

  end;

  MoveTo(X+dx,Y+dy);
  if BackFire <> Nil then
    BackFire.MoveTo(X,Y-44);


  if (Y > 500) Or (Y < -20) Or (X > 700) Or (X<-60) then begin
    Die;
  end;
end;

procedure TMissile1.MoveTo(xx,yy:Integer);
begin
  x:=xx;
  y:=yy;
  FOwner.Spr[mySpr].X:=xx-8;
  FOwner.Spr[mySpr].Y:=yy-24;
end;

procedure TMissile1.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
  if BackFire <> Nil then
    BackFire.Die;
end;

procedure TMissile1.OnDamaged(dmg:Integer);
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_Missile1;
    FOwner.Add(TFlare1.Create(FOwner,X,Y, 0));
    FOwner.Add(TSpark2.Create(FOwner, 8, 768,160, X,Y));
    SG.Play(CH_ENEMY1,PR_NORMAL,SE_ShootDown1);
    Die;
  end;
end;

procedure TMissile1.OnCrush(target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;








////////////////////////////
//obNt@CA
////////////////////////////
constructor TBackFire.Create(owner:TMoverList; s:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;

  mySpr:=FOwner.NewSprite();
  with FOwner.Spr[mySpr] do begin
    iShape:=s;
    MinAnim:=0;
    MaxAnim:=3;
    iAnim:=0;
    Visible:=True;
    RewindFlag:=False;
    Z:=Z_LOWER;      //LN^D揇ʒႢ
    AddMode:=USE_ADD;
  end;

end;

destructor TBackFire.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;

procedure TBackFire.Move(t:Integer);
begin
  inherited;

  FOwner.Spr[mySpr].NextFrame;
end;

procedure TBackFire.MoveTo(xx,yy:Integer);
begin
  with FOwner.Spr[mySpr] do begin
    X:=xx - Width Shr 1;
    Y:=yy;
  end;
end;

procedure TBackFire.OnDie;
begin
  FOwner.Spr[mySpr].Hide;
  inherited;
end;

end.
