unit powerItem;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddidex, defs, shkernel, moveUtil, ddraw, s_MathPack;

//ς[Ă
type TPowerItem = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    Rank:Integer;     //ǂꂾp[Ă邩(EENX^̏)
    v:TVector2D;        //x
    max_v:Single;     //ō̑
    pos:TVector2D;      //ʒu
  public
    constructor Create(owner:TMoverList; iRank,gx,gy:Integer; v0:TVector2D); //p[NEʒuE
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnCrush(Target:TMover); override; //Փˎ̃Cxg
end;


implementation

constructor TPowerItem.Create(owner:TMoverList; iRank,gx,gy:Integer; v0:TVector2D); //p[NEʒuE
begin
  inherited Create(owner);

  //蔻̏
  nTouchRect:=1;
  if iRank <> 2 then
    FTouchRect[0]:=Rect(-16,-8,+16,+8)
  else
    FTouchRect[0]:=Rect(-24,-10,+24,+10);
  FAttr:=maEB;    //@ɂȂ̂ŁAGe

  //ϐ̏
  v:=v0;
  pos:=Vector2D(gx,gy);
  rank:=iRank;
  max_v:=3.5 + Random*2.0;  //3.5`5.5͈̔͂ŕϓ

  //XvCg̏
  mySpr:=FOwner.NewSprite();
  with FOwner.Spr[mySpr] do begin
    iShape:=S_POWER;
    MinAnim:=iRank;
    MaxAnim:=9+iRank;
    iAnim:=iRank;
    Visible:=True;
    RewindAnim:=True;
    Z:=Z_NORMAL;
  end;

  MoveTo(gx,gy);
end;

destructor TPowerItem.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TPowerItem.OnDie;
begin
  inherited;
  Fowner.Spr[mySpr].Hide;
end;

procedure TPowerItem.Move(t:Integer);
begin
  inherited;

  //Aj
  if CanShootConst(0,15) then begin
    with FOwner.Spr[mySpr] do begin
      NextFrame;
      NextFrame;
      NextFrame;
    end;
  end;


  //ɉAő呬x5
  v.Y:=v.Y + t * 0.15;
  if v.Y > max_v then
    v.Y:=max_v;

  pos.X:=pos.X + v.X * t;
  pos.Y:=pos.Y + v.Y * t;

  MoveTo(Round(pos.X),Round(pos.Y));

  if Y > 500 then
    Die;
end;

procedure TPowerItem.MoveTo(xx,yy:Integer);
begin
  with FOwner.Spr[mySpr] do begin
    X:=xx - Width Shr 1;
    Y:=yy - Height Shr 1;
  end;
  X:=xx;
  Y:=yy;
end;


//Փˎ̃Cxg
procedure TPowerItem.OnCrush(Target:TMover);
var
  dPow:Integer;
begin
  inherited;


  //p[𑝂₷
  Case Rank of
    0:dPow:=2;
    1:dPow:=10;
    2:dPow:=50;
  end;

  Inc(FOwner.HeroPower,dPow);

  //GlM[^̎ɎƁA{[iX
  if FOwner.HeroPower > 500 then begin
    FOwner.HeroPower:=500;
    FOwner.Score:=FOwner.Score + dPow * 1000;
  end;
end;


end.
