unit Shooter1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ddraw,d3d,d3dcaps,d3dtypes,
  DDSD, dddd, ddddut, s_util,s_MathPack,
  SHKernel, defs, stars, hero, enemy, group, Ddidex, Menus, SE, Primitives;

//{$DEFINE PAL}

type
  TForm1 = class(TForm)
    DDDD1: TDDDD;
    DDIDEX1: TDDIDEX;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    S1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    DrvMenu: TMenuItem;
    DDSD1: TDDSD;
    procedure DDDD1Init(Sender: TObject; fNeedChange: Boolean);
    procedure DDDD1Restore(Sender: TObject);
    procedure DDDD1Destroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure S1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private 錾 }
    PCFreq:Int64; //PerfomanceCounter̎g[tick/ms]     
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure DriverChildClick(Sender:TObject);
    procedure SetupIM;
    //procedure MoveHero;
  public
    { Public 錾 }
    Star:TStars;
    Sphere:TBGSphere;
    FStarted:Boolean;   //ItO
    curDepth:Integer;
    procedure MoveCallBack(t:Integer);  //Movers.Movê߂̃R[obN
  end;

var
  Form1: TForm1;
  Movers:TMoverList;

implementation

uses splashWindow;

(*******************************************************************************
  C[v
*******************************************************************************)
var
  prevT:Int64 = 0;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
var
  ddc:TDDDDCanvas;
  curT:Int64;
  e:Int64;
  step:Integer; //R}i߂邩?
  scaps:DDSCAPS;
  totalMem,freeMem:DWord;
begin
  if not FStarted then begin
    exit;
  end;
  DDDD1.Clear;

  //t[[ǧvZ`t[XLbv
  QueryPerformanceCounter(curT);

  e:=(curT-prevT) div PCFreq;

  if e < 13 then begin     //A80fpsȏ̃Xq[hȂAt[҂
    while e<13 do begin
      QueryPerformanceCounter(curT);
      e:=(curT-prevT) div PCFreq;
      Application.ProcessMessages;
    end;
    DDDD1.WaitVBlank;

    QueryPerformanceCounter(curT);
    e:=(curT-prevT) div PCFreq;
    step:=1;
  end else if (e > 25) And (e < 50) then    //t[XLbv(40fps`20fps̏ꍇ)
    step:=2
  else if e >= 50 then        //20fpsȉȂA3R}
    step:=3
  else                                //ʂɕ\
    step:=1;

  //step:=1;
  Movers.Move(step);

  prevT:=curT;


  //낢\
  if DISP_PERFORMANCE then begin
    ddc:=TDDDDCanvas.Create(DDDD1.BackBuffer);
    if ddc.Enabled then begin
      ddc.Font.Name:='lr SVbN';
      ddc.Font.Color:=clAqua;
      ddc.Brush.Style:=bsClear;
      ddc.TextOut(0,0,  Format('FPS        %.6f',  [1000.0 / e]));
      ddc.TextOut(0,20, Format('Movers     %.8d',[Movers.Count]));
      ddc.TextOut(0,40, Format('Sprites    %.4d',[Movers.NSprites]));
      ddc.TextOut(0,60, Format('Primitives %.4d',[Movers.Rend.nPrims]));
      ddc.TextOut(0,80, Format('Triangles  %.4d',[Movers.Rend.nPrims*2]));
      ddc.TextOut(0,100,Format('Blt        %.4f Mclocks',[Movers.BltCLK / 1000000.0]));
      ddc.TextOut(0,120,Format('Touch      %.4f Mclocks',[Movers.TouchCLK / 1000000.0]));
      ddc.TextOut(0,140,Format('Move       %.4f Mclocks',[Movers.MoveCLK / 1000000.0]));
      ddc.TextOut(0,160,Format('Search     %.8d / %.8d ',[Movers.NCrush,Movers.NMaxCrush]));
      ddc.TextOut(0,180,Format('SCORE      %.8d',[Movers.Score]));
      ddc.TextOut(0,200,Format('MAXSCORE   %.8d',[Movers.MaxScore]));
    end;
    ddc.Free;
  end;

  DDDD1.Flip;

  Done:=False;
end;

//Movers.Movê߂̃R[obN
//BeginRender`Endrender̊Ԃɍs킹
procedure TForm1.MoveCallBack(t:Integer);
begin
  Sphere.Update(t);
  Star.Update(t);
end;


{$R *.DFM}



(*******************************************************************************
  
*******************************************************************************)
procedure TForm1.DDDD1Init(Sender: TObject; fNeedChange: Boolean);
var
  i:Integer;
  full:Boolean;
  mi:TMenuItem;
begin
  //ZpbP[W̏
  NowInit;

  //ptH[}XJE^̎gQb`
  QueryPerformanceFrequency(PCFreq);
  PCFreq:=PCFreq div 1000;

  //ϐ̏
  QD:=DDDD1;
  Sound:=DDSD1;
  Joy:=DDIDEX1;
  PATH := ExtractFilePath(Application.Exename);
  WAVEPATH   := PATH + 'wav\';
  IMGPATH    := PATH + 'bmp\';
  REPLAYPATH := PATH + 'replay\';
  ININAME    := PATH + 'shooter.ini';
  FStarted   := False;

  //j[̍쐬
  For i:=0 to DDDD1.DDDriverList.Count-1 do begin
    mi:=TMenuItem.Create(Form1);
    mi.Caption:=DDDD1.DDDriverList[i];
    mi.OnClick:=DriverChildClick;
    if DDDD1.DDDriverList.Objects[i]=Nil then
      mi.Checked:=True;
    drvMenu.Add(mi);
  end;


  //RtBO[VEBhE̕\
  Form2:=TForm2.Create(Application);
  Case Form2.ShowModal of
    mrYes: full:=True;
    mrNo:  full:=False;
    else
      Halt;
  end;

  if not Form2.CheckBox1.Checked then begin
    QD.D3DOptions:=[DontUseTnLHAL,DontUseHAL,DontUseMMX];
    USE_HAL:=False;
  end else begin
    QD.D3DOptions:=[];
    USE_HAL:=True;
  end;


  Form2.Release;

  //Joy.Initialize; //̓RtBOEBhE


  //ʃ[h̐ݒ
  //tXN[ȂȂAhCo̕ύX͂ł˂
  drvMenu.Enabled:=full;

  if full And DDDD1.IsAvailableDisplayMode(640,480,16,6000) then
    DDDD1.FullScreenMode(640,480,16,6000,'')
  else if full then
    DDDD1.FullScreenMode(640,480,16,0,'')
  else
    DDDD1.WindowMode(640,480);


  //IM
  SetupIM;

  //̃Xg̐
  Movers:=TMoverList.Create;
  Movers.MoveCallBack:=MoveCallBack;

  //wi̍쐬
  Star:=TStars.Create(DDDD1, NUM_STAR, 640,480, Movers.Textures['stars.bmp']);
  Sphere:=TBGSphere.Create(Movers.Textures['bg.bmp']);


  //}EXJ[\
  Screen.CurSor:=crDefault;
  ShowCursor(False);

  //vC}obt@̃tH[}bgw
  DDSD1.SetPrimaryBufferFotmat(22050,8,False);


  //C[v̎t
  Movers.TitleStart;
  Application.OnIdle:=AppIdle;
  FStarted:=True;
end;



  (* IM֘A̐ݒ *)
procedure TForm1.SetupIM;
var
  vp:D3DVIEWPORT7;
  r:D3DRect;
begin
  //r[|[g̐ݒ

  with vp do begin
    dwX:=0; dwY:=0;
    dwWidth:=QD.BackBuffer.Width;
    dwHeight:=QD.BackBuffer.Height;
    dvMinZ:=0;
    dvMaxZ:=1.0;
  end;
  QD.D3DDevice.SetViewport(@vp);


  //r[|[g̃NA
  with r do begin
    x1:=0;
    x2:=640;
    y1:=0;
    y2:=480;
  end;
  QD.D3DDevice.Clear(1,@r,D3DCLEAR_TARGET, $FF000000, 1.0, 0);

end;


procedure TForm1.DDDD1Restore(Sender: TObject);
begin
  //Movers.Restore;
  //Star.Restore(Movers.ImgSurf);
  {$IFDEF PAL}
  //DDDD1.ReadPalette(IMGPATH + 'images.bmp');
  //DDDD1.UpdatePalette;
  {$ENDIF}
end;

procedure TForm1.DDDD1Destroy(Sender: TObject);
begin
  Star.Free;
  Movers.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Application.Terminate
  else if ( (Key = Ord('A')) And (Shift = [ssCtrl])) then
    //USE_ADD:=not USE_ADD  //
  else if ( (Key = Ord('P')) And (Shift = [ssCtrl])) then
    DISP_PERFORMANCE:=not DISP_PERFORMANCE
  else if ( (Key = Ord('E')) And (Shift = [ssCtrl])) then
    DISABLE_SE := not DISABLE_SE
  else if FStarted then begin
    if (Key = VK_F5) And (Movers.GameState = gsGame) then
      Movers.GameEnd;
  end;
end;

//XibvVbg
procedure TForm1.S1Click(Sender: TObject);
var
  fname:String;
  i:Integer;
begin
  //gĂȂt@CT
  i:=0;
  while i<10000 do begin
    fname:='snap' + IntToStr(i) + '.bmp';
    if not FileExists(fname) then
      break;
    Inc(i);
  end;
  DDDD1.BackBuffer.SaveBMP(fname);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate
end;


////////////hCȏI
procedure TForm1.DriverChildClick(Sender:TObject);
var
  i:Integer;
  idx:Integer;
begin

  //`FbN
  idx:=-1;
  For i:=0 to DrvMenu.Count-1 do begin
    if DrvMenu.Items[i] = Sender then begin
      DrvMenu.Items[i].Checked:=True;
      idx:=i;
    end else
      DrvMenu.Items[i].Checked:=False;
  end;

  if idx = -1 then
    Exit;

  //hCo̕ύX
  if DDDD1.isAvailableDisplayMode(640,480,16,6000) then
    DDDD1.FullScreenMode(640,480,16,6000,DDDD1.DDDriverList[idx])
  else
    DDDD1.FullScreenMode(640,480,16,0,DDDD1.DDDriverList[idx]);

  //\[X̍č\z
  SetupIM;
  Movers.Setup;

end;


end.
