unit defs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddidex, dinput, SE, d3d, d3dtypes, d3dcaps;


type
  TIntArray = Array[0..$FFFFFF] of Integer;
  PIntArray = ^TIntArray;

  //
  //             @  e   G    Ge   ʏ      X[
  TMoverAttr = (maHero,maHB,maEnemy,maEB,maEraser,maWall,maThru);

  //Tu
  TMoverOption = set of (moNoSpark,moCustomDraw,moTarget,moEnemyLaser);
  //łƂĂΉԂoȂ,JX^`惋[`Ă,V[J[C̃^[QbgɂĂ

  TGameState = (gsGame,gsTitle,gsGameOver);


//jꂽƂ̏
type TDestroyInfo = record
  x,y:Integer;    //W
  point:Integer;  //̃L̊{_
end;


//et[ł̏oCtH
type TFrameInfo = record
  dx,dy:SmallInt; //ʒu
  Fired:Byte;   //? -1=ĂȂ 0=Ch 1=[K 2=V[J[C
  step:Byte;    //̃t[ɂ́ACgĂH
end;

type PDestroyInfo = ^TDestroyInfo;

const

  //GAMETIME = 900;
  GAMETIME = 10800; //t[Pʂł̃Q[̎

  NUM_STAR=80;  //̐

  NUM_SPR = 2048;           //ĕKvȃXvCg̖
  MAX_SPR = NUM_SPR-1;
  NUM_MOVER = 1024;
  MAX_MOVER = NUM_MOVER-1;  //ĕKvMover̐
  NUM_PRIMITIVES = 4096;
  MAX_PRIMITIVES = NUM_PRIMITIVES-1;  //ĕKvȃv~eBu̐

  SIZE_MOVER = 2048;        //Mover@ɕKvƎv郁

  NUM_RESTHERO = 2;       //ftHg̎c@
  //NUM_RESTHERO = 99;       //ftHg̎c@

  //c24̎
  FONT_WIDTH :Array[0..45] of Integer = (
    16,16,16,16, 16,16,16,16, 16,16,16,16, 16,16,16,16,
    16,18,17,18, 18,16,15,19, 19,06,12,16, 16,21,19,20,
    16,19,16,15, 16,16,17,25, 17,17,15,8,  32,32);
  //(TIMES NEW ROMAN)c16̎
  FONT2_WIDTH :Array[0..45] of Integer = (
    12,12,12,12, 12,12,12,12, 12,12,10,10, 14,14,14,11,
    12,15,13,14, 14,13,13,15, 15,09,11,15, 13,16,15,15,
    12,16,14,12, 13,14,15,16, 14,15,13,6,  16,16);

  T_FLY        = 50;      //@Ĕł鎞

  {
  S_HERO    = 2;                //q[[̃VFCvԍE{l
  S_BOSS1  = S_HERO+8;          //{X1
  S_BOSS1L = S_BOSS1+1;         //{X1̍̕
  S_BOSS1R = S_BOSS1L+1;        //{X1̉E̕
  S_BOSS1C = S_BOSS1R+1;        //{X1̃Jo[
  S_ZAKO1   = S_BOSS1C + 1;     //UR1
  S_ZAKO2   = S_ZAKO1 + 8;      //UR2
  S_ZAKO3   = S_ZAKO2 + 1;      //UR3
  S_ZAKO4   = S_ZAKO3 + 1;      //UR4 (UR)
  S_ZAKO5   = S_ZAKO4 + 8;      //UR5 (iUR)
  S_CARRIER = S_ZAKO5 + 8;      //ACeLA

  S_B1      = S_CARRIER + 1;    //1
  S_B2      = S_B1 + 4;         //2
  S_B3      = S_B2 + 6;         //3()
  S_B4      = S_B3 + 3;         //4
  S_TAMA1   = S_B4 + 4;         //m[}Vbg
  S_RAILGUN = S_TAMA1 + 5;      //[K
  S_ETAMA1  = S_RAILGUN + 3;    //Ge1
  S_ETAMA2  = S_ETAMA1 + 4;     //Ge2
  S_MISSILE1= S_ETAMA2 + 2;     //~TC1
  S_M1SMOKE = S_MISSILE1 + 1;   //~TC1̉
  S_S1      = S_M1SMOKE  + 4;   //Ή1
  S_S2      = S_S1 + 6;         //΂̕
  S_S3      = S_S2 + 8;         //΂̕()
  S_FIRE1   = S_S3 + 8;         //Ή
  S_HADOU   = S_FIRE1 + 4;      //{X1̔gC
  S_HIT1    = S_HADOU + 6;      //qbg}[N

  S_BFZAKO4 = S_HIT1 + 4;       //G4̃obNt@CA
  S_BFZAKO5 = S_BFZAKO4 + 6;    //G5̃obNt@CA

  S_POWER   = S_BFZAKO5 + 6;    //p[ACe

  S_GAMEOVER= S_POWER + 12;     //Q[I[o[̕
  S_LOGO    = S_GAMEOVER + 1;   //^CgS
  S_CREDIT  = S_LOGO + 1;       //X^btNWbg
  S_OPR     = S_CREDIT+1;       //OPERATION START̕
  S_RANK    = S_OPR+2;          //N̕
  S_INPUT   = S_RANK+8;         //INPUT MODE̕
  S_FORCE   = S_INPUT+6;        //FORCEɂĂ̕

  S_GGENO   = S_FORCE+6;        //SŃ{[iX
  S_G90     = S_GGENO+1;        //90%{[iX
  S_G80     = S_G90+1;          //80%{[iX
  S_I16     = S_G80+1;          //16{
  S_I8      = S_I16+1;          //8{
  S_I4      = S_I8+1;           //4{
  S_I2      = S_I4+1;           //2{
  S_MULTI   = S_I2+1;           //A{[iX

  S_SCORE   = S_MULTI+18;       //'SCORE'
  S_SCORENUM= S_SCORE+1;        //XRAp
  }

  NUM_SHAPE = 300;              //VFCv̑A܁A300Ⴂ
  NUM_TEXTUREPATTERNS = 200;    //eNX`ɂp^[̑

  //Z-OrderɊւ萔
  Z_TOP    = 6;   //Ƃɂԏ
  Z_ESHOT  = 5;   //G̒e
  Z_FLARE  = 4;   //
  Z_HIGH   = 3;   //Ə
  Z_NORMAL = 2;   //ʂ̋󒆕
  Z_SHOT   = 1;   //Vbg
  Z_LOWER  = 0;   //Ȃ񂩒ႢƂ

  Z_MAX    = Z_TOP;   //Zl̏




  //XRAɊւ萔
  SC_BOSS1 = 1000000;
  SC_BOSS1WEAPON = 500000;
  SC_BOSS1COVER = 100000;
  SC_BOSS2 = 10000000;
  SC_ZAKO1 = 2000;       //G
  SC_ZAKO2 = 50000;
  SC_ZAKO3 = 30000;
  SC_ZAKO4 = 80000;
  SC_ZAKO5 = 500;
  SC_ZAKO6 = 5000;
  SC_ZAKO7 = 20000;
  SC_ZAKO8 = 100000;
  SC_CARRIER = 1000;
  SC_MISSILE1 = 100;
  SC_EB1   = 0;        //e\ĂƁAt[ǂꂾ_邩H
  SC_DONT_A  = -0;    //A˂͂(E\
  //SC_MULTI:Array[0..7] of Integer = (1,3,7,15,31,63,127,255); //A{[iX_
  SC_MULTI:Array[0..8] of Integer = (1,2,3,4,5,6,7,8,9); //A{[iX_

  //IuWFNgԂŔԃbZ[WR[h
  MSG_IAMDIE = 1;       //
  MSG_GAMEOVER = 2;     //@Sł
  MSG_DESTROYED = 3;    //ZMA₵


  //{{[iXpAXvCg̑傫
  SIZE_MULTI:Array[0..8] of Integer = (32,32,32, 32,32,32, 32,32,32);


  //^CgS̃TCY
  SIZE_LOGOX = 384;
  SIZE_LOGOY = 80;
  MAX_LOGOX = SIZE_LOGOX - 1;
  MAX_LOGOY = SIZE_LOGOY - 1;
  HALF_LOGOX = SIZE_LOGOX div 2;
  HALF_LOGOY = SIZE_LOGOY div 2;
  SIZE_LOGOTEX = 128;
  MAX_LOGOTEX = SIZE_LOGOTEX -1;


  //FFX
  FFX_SHOT1 = 0;
  FFX_SHOT2 = 1;
  FFX_DAMAGED = 2;

var
  QD:TDDDD;
  Joy:TDDIDEX;
  Sound:TDDSD;
  SG:TSE; //
  ViewPort:IDirect3DViewPort2;

  USE_HAL:Boolean = True;          //HALgH

  NewID:Integer = 0;               //VMoverɕtID

  MemoryPool:Array[0..MAX_MOVER,1..SIZE_MOVER] of Byte;  //TMover̃蓖Ă邽߂̋

  SinT:Array[0..1023] of Integer;  //Sine[u(1024{)
  CosT:Array[0..1023] of Integer;  //Cose[u(1024{)
  FSinT:Array[0..1023]  of Single;  //
  FCosT:Array[0..1023]  of Single;
  PolarT:Array[0..MAX_LOGOY,0..MAX_LOGOX] of TPoint;  //ɍWe[u
  MoeMoe:Array[0..MAX_LOGOTEX,0..MAX_LOGOTEX] of Byte;
  LogoMask:Array[0..MAX_LOGOY,0..MAX_LOGOX] of Boolean; //Sp}XN

  //FFGtFNg
  FFx:Array[0..10] of IDirectInputEffect;

  PATH:String;        //st@C̏ꏊ
  ININame:String;     //INIt@C̖O
  IMGPATH:String;     //摜t@C
  WAVEPATH:String;    //SEt@C
  REPLAYPATH:String;  //vCf[^

  BTN_SHOT:Integer = 1;   //Vbg{^
  BTN_SHOT2:Integer = 0;  //Vbg2{^
  BTN_SHOT3:Integer = 2;  //Vbg3{^

  USE_ADD:Boolean = False;  //Fs
  USE_ANALOG:Boolean = False; //AiOœ͂s
  USE_FF:Boolean = False;     //tH[XtB[hobNg

  DISABLE_SE:Boolean = False; //ʉ̍Đ֎~

  DISP_PERFORMANCE:Boolean = False;

  //Q[x
  GAMELEVEL:Integer = 2;    //0...Kids  1...Normal  2...Hard


  //vC
  //REPLAY:Boolean = False;   //vCۂ
  //ReplayData:Array[0..200*60] of TFrameInfo;  //vCf[^
  //IReplay:Integer;          //vCf[^̂ǂĐ/L^Ă邩

  S_HERO    :Integer;   //q[[̃VFCvԍE{l
  S_LITHERO :Integer;
  S_BOSS1   :Integer;   //{X1
  S_BOSS1L  :Integer;   //{X1̍̕
  S_BOSS1R  :Integer;   //{X1̉E̕
  S_BOSS1C  :Integer;   //{X1̃Jo[
  S_BOSS2   :Integer;   //{X2
  S_ZAKO1   :Integer;   //UR1 ()
  S_ZAKO2   :Integer;   //UR2 (e)
  S_ZAKO3   :Integer;   //UR3 (~TC)
  S_ZAKO4   :Integer;   //UR4 ()
  S_ZAKO5   :Integer;   //UR5 (i)
  S_ZAKO6   :Integer;   //UR6 (WOUO)
  S_ZAKO7   :Integer;   //UR7 ([U[)
  S_ZAKO8   :Integer;   //UR8 (z[~O[U[)
  S_ZAKO9   :Integer;   //UR9 ({X2̌q)
  S_CARRIER :Integer;   //ACeLA

  S_B1      :Integer;   //1
  S_B2      :Integer;   //2
  S_B3      :Integer;   //3()
  S_B4      :Integer;   //4
  S_RAILGUN :Integer;   //[K
  S_ETAMA1  :Integer;   //Ge1(F)
  S_ETAMA2  :Integer;   //Ge2()
  S_MISSILE1:Integer;   //~TC1
  S_S2      :Integer;   //΂̕
  S_S3      :Integer;   //΂̕()
  S_FIRE1   :Integer;   //Ή({c)
  S_HIT1    :Integer;   //qbg}[N

  S_BFZAKO4 :Integer;   //G4̃obNt@CA
  S_BFZAKO5 :Integer;   //G5̃obNt@CA

  S_POWER   :Integer;   //p[ACe

  S_GAMEOVER:Integer;   //Q[I[o[̕
  S_GAMECLEAR:Integer;  //Q[NA̕
  S_LOGO    :Integer;   //^CgS
  S_CREDIT  :Integer;   //X^btNWbg
  S_OPR     :Integer;   //OPERATION START̕
  S_RANKING :Integer;   //RANKING̕
  S_RANK    :Integer;   //N̕
  S_INPUT   :Integer;   //INPUT MODE̕
  S_FORCE   :Integer;   //FORCEɂĂ̕

  S_GGENO   :Integer;   //SŃ{[iX
  S_G90     :Integer;   //90%{[iX
  S_G80     :Integer;   //80%{[iX
  S_I16     :Integer;   //16{
  S_I8      :Integer;   //8{
  S_I4      :Integer;   //4{
  S_I2      :Integer;   //2{
  S_MULTI   :Integer;   //A{[iX

  S_SCORE   :Integer;   //'SCORE'
  S_SCORENUM:Integer;   //XRAp


  //eNX`
  P_FONT    :Integer;   //tHg
  P_FONT2   :Integer;   //tHg(Times New Roman)
  P_BALL    :Integer;   //{[̊
  P_THUNDER :Integer;   //
  P_RING    :Integer;   //
  P_GRADBALL:Integer;   //Oft{[

  P_PILLAR  :Integer;   //Β
  P_B1      :Integer;   //(E)
  P_B2      :Integer;   //(IWE)
  P_B4      :Integer;   //(sNE)
  P_M1SMOKE :Integer;   //~TC1̉

  P_FLARE1  :Integer;   //YtA()
  P_FLARE2  :Integer;   //YtA()
  P_RINGL   :Integer;   //()
  P_SHOCK1  :Integer;    //MUMUՌg
  P_RIBBON  :Integer;   //cOf

  P_TAMA1   :Integer;   //m[}Vbg

  P_HADOU   :Integer;   //{X1̔gC

  P_BOSS2   :Integer;   //{X2
  P_SABRE   :Integer;   //{X2̓̃eNX`


//蓖ėp
procedure InitMemoryStack;
function  NewMoverMem:Integer;      //Moverp𓾂
procedure FreeMoverMem(idx:Integer);//Moverpԋp


implementation

var
  FreeMMSP:Integer;                       //MoverX^bN|C^
  FreeMM:Array[0..MAX_MOVER] of Integer;  //MoverX^bN



procedure InitMemoryStack;
var
  i:Integer;
begin
  //MoverX^bN̍쐬
  For i:=0 to MAX_MOVER do
    FreeMM[i]:=i;
  FreeMMSP:=0;
end;

function  NewMoverMem:Integer;        //󂫃ԍԂ
begin
  result:=FreeMM[FreeMMSP];  //X^bN̐擪n
  Inc(FreeMMSP);              //X^bN|C^𑝂₷
end;


procedure FreeMoverMem(idx:Integer);  //XvCgԋp
begin
  //X^bN̐擪߂B
  Dec(FreeMMSP);
  FreeMM[FreeMMSP]:=idx;
end;




end.
