unit demo;

//Q[I[o[E^CgƂA藧Ė

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddidex, defs, shkernel, moveUtil, ddraw, IniFiles,
  inputUT,se, primitives, s_MathPack;


//Q[I[o[S  
type TGameOver = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    PrevShot:Boolean; //{^͉ȂƎ̃V[ɍsȂ悤ɂ
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
end;

//Q[NAS
type TGameClear = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    PrevShot:Boolean; //{^͉ȂƎ̃V[ɍsȂ悤ɂ
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
end;



//LOǗNXAMover
type TScoreRecorder = class
  public
    Scores:Array[1..10] of Integer;  //XRA  cƉAʓ|Ȃ̂publicɂႤ
    Names:Array[1..10] of String;    //O

    constructor Create;
    destructor Destroy; override;
    function QueryRank(score:Integer):Integer;  //scoreLỎʂԂ
    function Regist(score:Integer; name:String):Integer; //LOɓo^
end;


//l[Gg
type TNameEntry = class(TTransMover)
  private
    Rec:TScoreRecorder;
    Name:String;        //ݓ̖͒O
    InputPos:Integer;   //J[\ʒu
    LetterPos:Integer;  //I𒆂̔̕ԍ
    PrevShot:Boolean;
    Rank:Integer;       //ʂɓH
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure  Move(t:Integer); override;
end;


//^Cgŕ\ARtBOj[
type TConfigMenu = class(TMover)
  private
    MySprs:Array[0..4] of Integer;
    FFocus:Boolean;
    Count:Integer;
    procedure SetVisible(v:Boolean);
  public
    ItemIndex:Integer;
    constructor Create(owner:TMoverList; Shapes:Array of Integer; PosY:Integer);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
    procedure Focus;
    procedure UnFocus;
    procedure Select(k:Integer);  //1ŉEIA-1ōI
    property Focused:Boolean read FFocus;
    property Visible:Boolean write SetVisible;
end;


//^Cg
type TTitle = class(TTransMover)
  private
    mySpr:Integer;    //\XvCgԍ(^Cg̃oi[)
    CreditSpr:Integer;  //NWbgp
    PrevShot:Boolean; //{^͉ȂƎ̃V[ɍsȂ悤ɂ
    PrevKey:Boolean;  //\L[܂
    Clut:Array[0..255] of DWord;  //[Ղā[Ԃ
    Menus:Array[0..4] of TConfigMenu; //0珇ɁAOprStart, Rank, InputMode, Force, Ranking
    Rec:TScoreRecorder;
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
    procedure Configure;  //݂̃RtBOACȅԂAQ[p̕ϐɔf
    procedure SaveConfig; //INIt@CɁAԂ
    procedure LoadConfig; //INIt@CAԂǂݍ
end;



//{[iX_\
type TGenocideMessage = class(TMover)
  protected
    mySpr:Integer;    //\XvCgԍ
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
end;

type TGenocideBonus = class(TGenocideMessage)
  public
    constructor Create(owner:TMoverList);
end;

type TG90Bonus = class(TGenocideMessage)
  public
    constructor Create(owner:TMoverList);
end;

type TG80Bonus = class(TGenocideMessage)
  public
    constructor Create(owner:TMoverList);
end;


//CpNg{[iX\
type TImpactMessage = class(TGenocideMessage)
  public
    constructor Create(owner:TMoverList; p:TPoint);
end;

//A{[iX\
type TMultipleMessage = class(TMover)
  protected
    nGrade:Integer;
    mySpr:Integer;    //\XvCgԍ
  public
    constructor Create(owner:TMoverList; nCont:Integer; x,y:Integer);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
end;



//XRAEԁEc@\
type TScoreDisplay = class(TMover)
  private
    RestSpr:Array[0..2] of Integer; //@̊GE
    ScoreSpr:Array[0..11] of Integer;
    HeadSpr:Integer;
    TimeSpr:Array[0..6] of Integer;
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure OnDie; override;
    procedure Move(t:Integer); override;
end;




implementation

//eLXg
type TTextAlign = (taLeft,taCenter,taRight);


//̕`
procedure DrawString(owner:TMoverList; prop:Boolean; largeFont:Boolean; align:TTextAlign; left,top,height:Single; col:DWord; mode:TBlendMode; str:String);
var
  i,ch:Integer;
  x,y:Single;
  width:Single;
  st:Single;    //̃TCY(largeȂ24AłȂȂ16)
  pat:Integer;
begin
  x:=left;
  y:=top;

  if largeFont then
    st:=24
  else
    st:=16;


  //̒vZ
  width:=0;
  for i:=1 to Length(str) do begin
    ch:=Ord(str[i]) - $30;
    if prop then begin
      if ch >= 0 then
        if largeFont then
          width:=width + FONT_WIDTH[ch] * height / st
        else
          width:=width + FONT2_WIDTH[ch] * height / st
      else
        width:=width + st * 0.7;
    end else
      width:=width+height;
  end;

  //ʒuɉĕ`JnʒȕC
  Case align of
    taLeft:   x:=left;
    taCenter: x:=left - width/2.0;
    taRight:  x:=left - width;
  end;

  for i:=1 to Length(str) do begin
    //LN^ԍ̌vZ
    ch:=Ord(str[i]) - $30;

    //tHgI
    if largeFont then
      pat:=P_FONT
    else
      pat:=P_FONT2;

    //`
    if ch >= 0 then begin
      owner.Rend.PushPatternRect(pat + ch,
        SingleRect(x,y,x+height,y+height),
        Z_TOP,mode,col);
    end;

    //v|[Viŕ`悷ȂAf[^ɏ]
    if prop then begin
      if ch >= 0 then
        if largeFont then
          x:=x + FONT_WIDTH[ch] * height / st
        else
          x:=x + FONT2_WIDTH[ch] * height / st
      else
        x:=x + st * 0.7;
    end else
      x:=x + height;
  end;

end;






constructor TGameOver.Create(owner:TMoverList);
var
  fs:TFileStream;
begin
  inherited;

  PrevShot:=True;
  FAttr:=maThru;

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_GAMEOVER;
    iAnim:=0;
    Visible:=True;
    Z:=Z_TOP;
  end;

  FOwner.Spr[mySpr].Pos:=Point( (640-320) div 2,(480-48) div 3);

  {
  //vCf[^̕ۑ
  if not REPLAY then begin
    try
      fs:=TFileStream.Create(REPLAYPATH + 'LastGame.rp',fmCreate);
      fs.Write(ReplayData,Sizeof(ReplayData));
      fs.Free;
    except
    end;
  end;
  }

end;



procedure TGameOver.OnDie;
begin
  inherited;

  FOwner.Spr[mySpr].Hide;

  //l[GgIuWFNg𐶐
  FOwner.Add(TNameEntry.Create(Fowner));

  //if FOwner.GameState = gsGameOver then
  //  FOwner.GameEnd;
end;

destructor TGameOver.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;


procedure TGameOver.Move(t:Integer);
begin
  inherited;

  if ( (ageT>20) And (not PrevShot) And AnyButtonPushed() ) then
    Die();

  PrevShot:=AnyButtonPushed();
end;





/////////////////////////////// Q[NASEf
constructor TGameClear.Create(owner:TMoverList);
var
  fs:TFileStream;
begin
  inherited;

  PrevShot:=True;
  FAttr:=maThru;

  mySpr:=FOwner.NewSprite();
  FOwner.TimeStop:=True;  //Ԃ̌o߂Xgbv

  with FOwner.Spr[mySpr] do begin
    iShape:=S_GameClear;
    iAnim:=0;
    Visible:=True;
    Z:=Z_TOP;
  end;

  FOwner.Spr[mySpr].Pos:=Point( (640-272) div 2,(480-48) div 3);
end;



procedure TGameClear.OnDie;
begin
  inherited;

  FOwner.Spr[mySpr].Hide;

  //l[GgIuWFNg𐶐
  FOwner.Add(TNameEntry.Create(Fowner));

end;

destructor TGameClear.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;


procedure TGameClear.Move(t:Integer);
begin
  inherited;

  if ( (ageT>20) And (not PrevShot) And AnyButtonPushed() ) then
    Die();

  PrevShot:=AnyButtonPushed();
end;






////////////////////XRAL^pIuWFNg

constructor TScoreRecorder.Create;
var
  ini:TINIFile;
  i:Integer;
begin
  ini:=TINIFile.Create(ININame);

  //LO̓ǂݎ
  for i:=1 to 10 do begin
    Names[i] :=ini.ReadString ('RANKING','NAME'+IntToStr(i), 'SANDMAN');
    Scores[i]:=ini.ReadInteger('RANKING','SCORE'+IntToStr(i),(11-i)*1000000);
  end;

  ini.Free;
end;


destructor TScoreRecorder.Destroy;
begin
  inherited;
end;


//scoreLỎʂԂ
function TScoreRecorder.QueryRank(score:Integer):Integer;
var
  i:Integer;
begin
  result:=11;

  for i:=1 to 10 do begin
    if Scores[i] < score then begin
      result:=i;
      exit;
    end;
  end;
end;


//LOɓo^
function TScoreRecorder.Regist(score:Integer; name:String):Integer;
var
  i,rank:Integer;
  ini:TIniFile;
begin
  rank:=QueryRank(score);

  if rank <= 10 then begin
    for i:=10 downto rank+1 do begin
      Scores[i]:=Scores[i-1];
      Names[i] :=Names[i-1];
    end;
    Scores[rank]:=score;
    Names[rank]:=name;

    ini:=TINIFile.Create(ININame);
    for i:=1 to 10 do begin
      ini.WriteString('RANKING','NAME' +IntToStr(i), Names[i]);
      ini.WriteInteger('RANKING','SCORE'+IntToStr(i), Scores[i]);
    end;
    ini.Free;
  end;
end;








//////////////////////////l[Gg

constructor TNameEntry.Create(owner:TMoverList);
begin
  inherited Create(owner);

  //ϐ̏
  Rec:=TScoreRecorder.Create;
  State:=0;

  InputPos:=17*32;
  LetterPos:=0;
  Name:='';
  PrevShot:=True;

  //AiOEfW^Ɋւ炸Afbh][L
  Joy.DeadZone:=33;

  FAttr:=maThru;
  rank:=Rec.QueryRank(FOwner.Score);

  //10ʈȓȂȂA
  if rank > 10 then
    Die;
end;

destructor TNameEntry.Destroy;
begin
  Rec.Free;

  inherited;
end;

procedure TNameEntry.OnDie;
begin
  inherited;

  if FOwner.GameState = gsGameOver then
    FOwner.GameEnd;
end;

procedure  TNameEntry.Move(t:Integer);
var
  i:Integer;
  ch:Integer;
  phase:Single;
  rankStr:String;
  bm:TBlendmode;  //LvṼuh[h(Ă鎞Add,ƂDecal)

  //F
  DefCaptionCol1,CaptionCol1:DWord;  //YOU MADE IT
  DefCaptionCol2,CaptionCol2:DWord;  //YOUR RANK
  DefRankCol,RankCol:DWord;      //xxxTH
  DefNameCol,NameCol:DWord;      //name
  DefLetterCol,LetterCol:DWord;  //ABCD...

begin
  inherited;

  CaptionCol1:=$FFFF8040;   DefCaptionCol1:=CaptionCol1;
  CaptionCol2:=$FFFFFFFF;   DefCaptionCol2:=CaptionCol2;
  RankCol:=$FF80C0FF;       DefRankCol:=RankCol;
  NameCol:=$FFFFC0E0;       DefNameCol:=NameCol;
  LetterCol:=$FFFFFFFF;     DefLetterCol:=LetterCol;

  if Rank > 10 then
    Exit;

  Case State of
    0:begin //͎󂯕t
      //EL[ŁAI
      if Joy.Stick.X < 0 then
        State:=1
      else if Joy.Stick.X > 0 then
        State:=2;

      //AC{^őI𕶎
      if (Joy.Buttons[BTN_SHOT3] or Joy.Buttons[BTN_SHOT2]) And (not PrevShot) then begin
        ch:=InputPos Shr 5;

        Case ch of
          0..43: begin  //
            if LetterPos<8 then begin
              SG.Play(CH_SYSTEM,PR_NORMAL,SE_ShootDown1); //ʉ
              Inc(LetterPos);
              Name:=Name + Chr(InputPos Shr 5 + $30);
              if LetterPos = 8 then
                InputPos:=45 * 32;  //{^̏ɃJ[\u
            end;
          end;
          44: begin //obN
            if LetterPos > 0 then begin
              SG.Play(CH_SYSTEM,PR_NORMAL,SE_Gokubuto1); //ʉ
              Name:=Copy(Name,1,Length(Name)-1);
              Dec(LetterPos);
            end;
          end;
          45: begin //
            SG.Play(CH_SYSTEM,PR_NORMAL,SE_ShootDown1); //ʉ
            //LOɓo^
            Rec.Regist(FOwner.Score,Name);
            State:=3; //Ԃ̕ύX
          end;
        end;

      end;
      //B{^ŃLZ
      if Joy.Buttons[BTN_SHOT] And (LetterPos > 0) And (not PrevShot) then begin
        Name:=Copy(Name,1,Length(Name)-1);
        Dec(LetterPos);
        SG.Play(CH_SYSTEM,PR_NORMAL,SE_Gokubuto1); //ʉ
      end;

      PrevShot:=Joy.Buttons[BTN_SHOT3] or Joy.Buttons[BTN_SHOT] or Joy.Buttons[BTN_SHOT2];
    end;

    1: begin  //J[\ړ()
      Dec(InputPos,t*6);
      //bvAEh
      if InputPos < 0 then
        Inc(InputPos,46*32);  //*sNZ

      if StateT > 6 then begin
        InputPos:=InputPos And (not $1F) + 32;
        State:=0;
      end;
    end;
    2: begin  //J[\ړ(E)
      //bvAEh
      Inc(InputPos,t*6);
      if InputPos >= 46*32 then
        Dec(InputPos,46*32);

      if StateT > 6 then begin
        InputPos:=InputPos And (not $1F);
        State:=0;
      end;
    end;

    3: begin  //͏ĨtF[hAEgcO
      CaptionCol1:=NowScaleColor(DefCaptionCol1,1.0-StateT/60.0);
      CaptionCol2:=NowScaleColor(DefCaptionCol2,1.0-StateT/60.0);
      LetterCol:=NowScaleColor(DefLetterCol,1.0-StateT/60.0);;
      if StateT > 60 then begin
        State:=4;
      end;
    end;
    4: begin
      CaptionCol1:=0;
      CaptionCol2:=0;
      LetterCol:=0;
      RankCol:=NowScaleColor(DefRankCol,1.0-StateT/60.0);
      NameCol:=NowScaleColor(DefNameCol,1.0-StateT/60.0);
      if StateT > 120 then  //Ăƃ^
        Die;
    end;


  end;

  ////`

  //InputPosÿʒuBInputPos Shr 5Ńy̍ĂLN^B
  //}5͈̔͂̃L\
  for i:=-5 to 5 do begin
    //\p^[ԍ𓾂
    ch:=InputPos Shr 5 + i;
    if ch < 0 then
      ch:=ch + 46
    else if ch >= 46 then
      ch:=ch - 46;

    //̓fJ
    if i = 0 then begin
      FOwner.Rend.PushPatternRect(P_FONT + ch,SingleRect(296-(InputPos And $1F), 292, 336-(InputPos And $1F), 332),
        Z_TOP,bmAdd,NowScaleColor(LetterCol,1.2 - Abs(i/5.0)));
    end else begin
      FOwner.Rend.PushPatternRect(P_FONT + ch,SingleRect(304+i*32-(InputPos And $1F), 300, 328+i*32-(InputPos And $1F), 324),
        Z_TOP,bmAdd,NowScaleColor(LetterCol,1.2 - Abs(i/5.0)));
    end;
  end;

  //͂Ă閼O̕`
  phase:=Sin(2*Pi * AgeT / 120) + 1.0;
  DrawString(FOwner,  False,True, taCenter, 320,240, 32, NowScaleColor(NameCol,phase*0.5 + 1.0),bmAdd, Name);

  //LvV
  Case Rank of
    1: rankStr:='1ST';
    2: rankStr:='2ND';
    3: rankStr:='3RD';
    4..10: rankStr:=IntToStr(Rank) + 'TH';
  end;

  //2śAiDecal,tF[hAEgAdd
  if State >= 3 then
    bm:=bmAdd
  else
    bm:=bmDecal;

  if Rank = 1 then
    DrawString(FOwner, True,True, taCenter, 320,122, 24, CaptionCol1,bm, 'CONGRATULATION')
  else
    DrawString(FOwner, True,True, taCenter, 320,122, 24, CaptionCol1,bm, 'YOU MADE IT');

  DrawString(FOwner, True,True, taCenter, 320,150, 24, CaptionCol2,bm, 'YOUR RANK');


  DrawString(FOwner, True,True, taCenter, 320,176, 48, NowScaleColor(RankCol,phase*0.5 + 1.0),bmAdd, rankStr);


end;









////////////////////^Cg
constructor TTitle.Create(owner:TMoverList);
var
  i,r,g,b:Integer;
begin
  inherited;

  PrevShot:=True;
  PrevKey:=True;
  FAttr:=maThru;
  State:=0;

  rec:=TScoreRecorder.Create;

  mySpr:=FOwner.NewSprite();
  CreditSpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iAnim:=0;
    iShape:=S_LOGO;
    Visible:=True;
    Z:=Z_TOP;
    X:=(640-384) div 2;
    Y:=(480-80) div 3
  end;

  with FOwner.Spr[CreditSpr] do begin
    iAnim:=0;
    iShape:=S_CREDIT;
    Visible:=True;
    Z:=Z_TOP;
    X:=(640-Width) div 2;
    Y:= 460;
  end;



  //CLUT̍쐬
  //QD.InitColorConverter(QD.BackBuffer.Desc.ddpfPixelFormat);
  for i:=0 to 255 do begin
    if i < 16 then
      Clut[i]:=0
    else begin
      r:=i;
      g:=i*2;
      b:=i*4;

      if r>255 then
        r:=255;
      if g>255 then
        g:=255;
      if b>255 then
        b:=255;

      Clut[i]:=QD.ARGBToPhysical(255,r,g,b);
    end;
  end;

  //eNX`̏
  ZeroMemory(@MoeMoe,sizeof(MoeMoe));

  //j[̍쐬
  Menus[0]:=TConfigMenu.Create(owner, [S_OPR], 300);  //OPERATION START
  Menus[1]:=TConfigMenu.Create(owner, [S_RANKING], 330); //RANKING
  Menus[2]:=TConfigMenu.Create(owner, [S_RANK,S_RANK+2,S_RANK+4,S_RANK+6], 360);  //RANK
  Menus[3]:=TConfigMenu.Create(owner, [S_INPUT,S_INPUT+2,S_INPUT+4], 380);  //INPUT MODE
  Menus[4]:=TConfigMenu.Create(owner, [S_FORCE,S_FORCE+2,S_FORCE+4], 400);  //FORCE

  For i:=0 to 4 do begin
    FOwner.Add(Menus[i]);
    Menus[i].ItemIndex:=1;
  end;

  Menus[0].Focus;

  //ݒ̓ǂݍ
  LoadConfig;
end;


destructor TTitle.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  FOwner.FreeSprite(CreditSpr);
  rec.Free;
  inherited;
end;


procedure TTitle.Move(t:Integer);
var
  i,x,y,v,rx,ry,tv:Integer;
  r:TPoint;
  ddsd:DDSurfaceDesc2;
  pLine:PByte;
  pPix:PWord;
  f:Array[0..MAX_LOGOTEX] of Integer;
  index:Integer;
begin
  inherited;

  //̕ωʂ
  f[0]:=Random(12);
  For x:=1 to MAX_LOGOTEX div 2 do begin
    f[x]:=f[x-1] + Random(7) - 3;
  end;
  For x:=MAX_LOGOTEX div 2 + 1 to MAX_LOGOTEX do begin
    f[x]:=f[MAX_LOGOTEX - x];
  end;

  //MoeMoe`
  For y:=MAX_LOGOTEX downto 1 do begin
    For x:=MAX_LOGOTEX downto 0 do begin
      v:=MoeMoe[y-1,x];
      Dec(v,f[x]);

      if (y And 31 = 0) Or (x = y) then
        Inc(v,64);

     if v<0 then
        v:=0
      else if v>255 then
        v:=255;
      MoeMoe[y,x]:=v;
    end;
  end;


  //gl邬[
  if FOwner.LogoSurf.IsLost then
    Exit;

  FOwner.LogoSurf.Lock(ddsd);
  pLine:=ddsd.lpSurface;

  for y:=0 to MAX_LOGOY do begin
    pPix:=Pointer(pLine);
    for x:=0 to MAX_LOGOX do begin
      if not LogoMask[y,x] then begin
        r:=PolarT[y,x];

        rx:=(r.X) And MAX_LOGOTEX;
        ry:=(r.Y - AgeT) And MAX_LOGOTEX;
        tv:=MoeMoe[ry,rx];//((MoeMoe[ry,rx] * Darkness[r.Y*3]) Shr 8);

        tv:=tv * r.y Shr 6;

        if tv > 255 then
          tv:=255;

        pPix^:=Clut[tv];
      end;
      Inc(pPix);
    end;
    Inc(pLine,ddsd.lPitch);
  end;

  FOwner.LogoSurf.Unlock;



  //L[ǂݎ
  Joy.DeadZone:=33;

  Case State of
    0: begin
      if not PrevKey then begin
        //\L[̏㉺ŁAs̑I

        //܂AݑIĂsQbg
        For i:=Low(Menus) to High(Menus) do begin
          if Menus[i].Focused then
            index:=i;
        end;
        //ŁAړ
        if (Joy.Stick.Y = -1) And (not (index = Low(Menus))) then begin
          Menus[index].Unfocus;
          Menus[index-1].Focus;
        end else if (Joy.Stick.Y = +1) And (not (index = High(Menus))) then begin
          Menus[index].Unfocus;
          Menus[index+1].Focus;
        end;

        //\L[̍EŁAI
        Menus[index].Select(Joy.Stick.X);
      end;


      if (not PrevShot) And (AnyButtonPushed()) then begin
        if Menus[0].Focused then  //OPERATION START̏Ń{^ꂽAQ[X^[g
          Die();
        if Menus[1].Focused then begin //RANKING̏Ń{^ꂽALO\
          For i:=0 to High(Menus) do
            Menus[i].Visible:=False;
          State:=1;
        end;
      end;


      PrevShot:=AnyButtonPushed();
      PrevKey:= (Joy.Stick.X <> 0) Or (Joy.Stick.Y <> 0);
    end;


    //LO
    1: begin  //tF[hC
      For i:=1 to 10 do begin
        DrawString(FOwner,False,False, taRight, 170,220+i*17,16, NowScaleColor($FFFFFFFF,StateT/60),bmAdd, IntToStr(i));
        DrawString(FOwner, True,False, taLeft,  180,220+i*17,16, NowScaleColor($FFFFC0FF,StateT/60),bmAdd, Rec.Names[i]);
        DrawString(FOwner, True,False, taRight, 510,220+i*17,16, NowScaleColor($FFFF8014,StateT/60),bmAdd, IntToStr(Rec.Scores[i]));
      end;
      if StateT > 60 then
        State:=2;
    end;
    2: begin  //\
      For i:=1 to 10 do begin
        DrawString(FOwner,False,False, taRight, 170,220+i*17,16, $FFFFFFFF,bmDecal, IntToStr(i));
        DrawString(FOwner, True,False, taLeft,  180,220+i*17,16, $FFFFC0FF,bmDecal, Rec.Names[i]);
        DrawString(FOwner, True,False, taRight, 510,220+i*17,16, $FFFF8014,bmDecal, IntToStr(Rec.Scores[i]));
      end;

      //{^ꂽA
      if (not PrevShot) And AnyButtonPushed then begin
        For i:=0 to High(Menus) do
          Menus[i].Visible:=True;
        State:=3;
      end;
      PrevShot:=AnyButtonPushed();
    end;
    3: begin  //tF[hAEg
      For i:=1 to 10 do begin
        DrawString(FOwner,False,False, taRight, 170,220+i*17,16, NowScaleColor($FFFFFFFF,1.0-StateT/60),bmAdd, IntToStr(i));
        DrawString(FOwner, True,False, taLeft,  180,220+i*17,16, NowScaleColor($FFFFC0FF,1.0-StateT/60),bmAdd, Rec.Names[i]);
        DrawString(FOwner, True,False, taRight, 510,220+i*17,16, NowScaleColor($FFFF8014,1.0-StateT/60),bmAdd, IntToStr(Rec.Scores[i]));
      end;
      if StateT > 60 then
        State:=0;
    end;


  end;

end;

procedure TTitle.OnDie;
var
  i:integer;
begin
  inherited;

  FOwner.Spr[mySpr].Hide;
  FOwner.Spr[CreditSpr].Hide;

  //݂̃RtBOACȅԂAQ[p̕ϐɔf
  Configure;
  SaveConfig; //ŁAZ[u

  For i:=0 to High(Menus) do
    Menus[i].Die;

  if FOwner.GameState = gsTitle then
    FOwner.GameStart;
end;



//݂̃RtBOACȅԂAQ[p̕ϐɔf
procedure TTitle.Configure;
begin

  GAMELEVEL:=Menus[2].ItemIndex-1;
  USE_ANALOG:=Menus[3].ItemIndex = 2;
  USE_FF:= Menus[4].ItemIndex = 2;


end;



//INIt@CɁAԂ
procedure TTitle.SaveConfig;
var
  ini:TIniFile;
begin
  //INIt@CɃZ[u
  ini:=TIniFile.Create(ININame);

  ini.WriteInteger('OPTION','GAMELEVEL',Menus[2].ItemIndex);
  ini.WriteInteger('OPTION','INPUTMODE',Menus[3].ItemIndex);
  ini.WriteInteger('OPTION','FORCE',    Menus[4].ItemIndex);

  //L[RtBO
  ini.WriteInteger('OPTION','BTN_SHOT1',BTN_SHOT);
  ini.WriteInteger('OPTION','BTN_SHOT2',BTN_SHOT2);

  ini.Free;
end;

//INIt@CAZ[uꂽԂǂݍ
procedure TTitle.LoadConfig;
var
  ini:TIniFile;
begin
  ini:=TIniFile.Create(ININame);

  //IvV̓ǂݍ
  Menus[2].ItemIndex:=ini.ReadInteger('OPTION','GAMELEVEL',3);  //ftHgłEXTREME
  Menus[3].ItemIndex:=ini.ReadInteger('OPTION','INPUTMODE',1);  //ftHgłDIGITAL
  Menus[4].ItemIndex:=ini.ReadInteger('OPTION','FORCE',1);      //ftHgłENABLE

  //L[RtBO
  BTN_SHOT:=ini.ReadInteger('OPTION','BTN_SHOT1',1);
  BTN_SHOT2:=ini.ReadInteger('OPTION','BTN_SHOT2',0);

  ini.Free;
end;


////////////////////{[iX
constructor TGenocideMessage.Create(owner:TMoverList);
begin
  inherited;

  FAttr:=maThru;

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iAnim:=0;
    iShape:=S_GGENO;
    Visible:=True;
    Z:=Z_TOP;
    AddMode:=False;
  end;

  FOwner.Spr[mySpr].Pos:=Point( (640-FOwner.Spr[MySpr].Width) div 2,(480-FOwner.Spr[MySpr].Height) div 3);

end;


destructor TGenocideMessage.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;


procedure TGenocideMessage.Move(t:Integer);
begin
  inherited;

  //bŎ
  if AgeT > 60 then
    Die;
end;

procedure TGenocideMessage.OnDie;
begin
  inherited;

  FOwner.Spr[mySpr].Hide;
end;




////////////////////SŃ{[iX
constructor TGenocideBonus.Create(owner:TMoverList);
begin
  inherited;

  FOwner.Spr[MySpr].IShape:=S_GGENO;
  FOWner.Score:=FOWner.Score + 5000000;

end;

constructor TG90Bonus.Create(owner:TMoverList);
begin
  inherited;

  FOwner.Spr[MySpr].IShape:=S_G90;
  FOWner.Score:=FOWner.Score + 1000000;
end;

constructor TG80Bonus.Create(owner:TMoverList);
begin
  inherited;

  FOwner.Spr[MySpr].IShape:=S_G80;
  FOWner.Score:=FOWner.Score + 500000;
end;


constructor TImpactMessage.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);

  FAttr:=maThru;

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iAnim:=0;
    iShape:=S_I16;
    Visible:=True;
    Z:=Z_TOP;
    AddMode:=False;
  end;

  FOwner.Spr[mySpr].Pos:=p;
end;





////////////////////XRA\
constructor TScoreDisplay.Create(owner:TMoverList);
var
  i:Integer;
begin
  inherited;

  FAttr:=maThru;

  HeadSpr:=FOwner.NewSprite();  //'SCORE'̕
  with FOwner.Spr[HeadSpr] do begin
    Pos:=Point( (640-(12*12+96)) Shr 1,0);
    iShape:=S_SCORE;
    iAnim:=0;
    Visible:=True;
    Z:=Z_TOP;
  end;

  //XRA\
  For i:=0 to 11 do begin
    ScoreSpr[i]:=FOwner.NewSprite();
    with FOwner.Spr[ScoreSpr[i]] do begin
      iShape:=S_SCORENUM;
      iAnim:=10;
      Visible:=True;
      Z:=Z_TOP;
      Pos:=Point( (640-(12*12+96)) Shr 1 + (8+i)*12,0);
    end;
  end;

  //c莞(1/1000bP)
  For i:=0 to 6 do begin
    TimeSpr[i]:=FOwner.NewSprite();
    with FOwner.Spr[TimeSpr[i]] do begin
      iShape:=S_SCORENUM;
      iAnim:=10;
      Visible:=True;
      Z:=Z_TOP;
      Pos:=Point( 620- (12*(6-i)), 440);
    end;
  end;

  //c@
  For i:=0 to 2 do begin
    RestSpr[i]:=FOwner.NewSprite();
    with FOwner.Spr[RestSpr[i]] do begin
      iShape:=S_SCORENUM;
      iAnim:=10;
      Visible:=True;
      Z:=Z_TOP;
      Pos:=Point(20 + (12*i), 440);
    end;
  end;

  with FOwner.Spr[RestSpr[0]] do begin
    IAnim:=0;
    IShape:=S_HERO;
    Width:=32;
    Height:=32;
    Pos:=Point(0, 440);
  end;

end;



procedure TScoreDisplay.OnDie;
var
  i:Integer;
begin
  inherited;

  FOwner.Spr[HeadSpr].Hide;
  For i:=0 to 11 do
    FOwner.Spr[ScoreSpr[i]].Hide;
  For i:=0 to 6 do
    FOwner.Spr[TimeSpr[i]].Hide;
  For i:=0 to 2 do
    FOwner.Spr[RestSpr[i]].Hide;
end;

destructor TScoreDisplay.Destroy;
var
  i:Integer;
begin
  FOwner.FreeSprite(HeadSpr);
  For i:=0 to 11 do
    FOwner.FreeSprite(ScoreSpr[i]);
  For i:=0 to 6 do
    FOwner.FreeSprite(TimeSpr[i]);
  For i:=0 to 2 do
    FOwner.FreeSprite(RestSpr[i]);

  inherited;
end;


procedure TScoreDisplay.Move(t:Integer);
var
  i,k:Integer;
  found:Boolean;  //0ȂtO
  s:String[12];
begin
  inherited;

  //XRA\
  s:=Format('%.12d',[FOwner.Score]);
  found:=False;
  For i:=1 to 12 do begin
    k:=StrToInt(s[i]);
    if (k = 0) then begin
      if not found then
        FOwner.Spr[ScoreSpr[i-1]].IAnim:=10
      else
        FOwner.Spr[ScoreSpr[i-1]].IAnim:=0;
    end else begin
      found:=True;
      FOwner.Spr[ScoreSpr[i-1]].IAnim:=k;
    end;
  end;

  //\
  if FOwner.GameState = gsGame then begin

    if FOwner.TimeStop then begin
      //^CXgbvc_łCfJ\͂Ȃ
      For i:=1 to 7 do begin
        With FOwner.Spr[TimeSpr[i-1]] do begin
          Pos:=Point( 620- (12*(7-i)), 440);
          ResetSize;
          Visible:= (FOwner.NCalled And 1) = 0;
        end;
      end;
    end else if FOwner.RestTime < 600 then begin
      //c10b؂̂ŁAł\
      For i:=1 to 7 do begin
        With FOwner.Spr[TimeSpr[i-1]] do begin
          Pos:=Point( ((640-24*7) Shr 1) + 48*i, 160);
          Width:=64;
          Height:=128;
          Visible:= (FOwner.NCalled And 1) = 0;
        end;
      end;
    end else begin
      //ʂ̏ԁAtbVƂ̓iV
      For i:=1 to 7 do
        FOwner.Spr[TimeSpr[i-1]].Show;
    end;


    s:=Format('%.3d',[FOwner.RestTime div 60]);
    s:=s + '.' + Format('%.3d',[(FOwner.RestTime mod 60) * 1000 div 60]);
    For i:=1 to 7 do begin
      if (s[i] = '-') then
        FOwner.Spr[TimeSpr[i-1]].IAnim:=10
      else if(s[i]='.') then
        FOwner.Spr[TimeSpr[i-1]].IAnim:=11
      else begin
        k:=StrToInt(s[i]);
        FOwner.Spr[TimeSpr[i-1]].IAnim:=k;
      end;
    end;
  end else begin
    For i:=0 to 6 do
      FOwner.Spr[TimeSpr[i]].Hide;
  end;


  //c@\
  if FOwner.GameState = gsGame then begin
    s:=Format('%.2d',[FOwner.RestHero]);
    k:=StrToInt(s[1]);
    if k = 0 then
      FOwner.Spr[RestSpr[1]].IAnim:=10
    else
      FOwner.Spr[RestSpr[1]].IAnim:=k;

    k:=StrToInt(s[2]);
    FOwner.Spr[RestSpr[2]].IAnim:=k;
  end else begin
    For i:=0 to 2 do
      FOwner.Spr[RestSpr[i]].Hide;
  end;

end;





////////////////////A{[iX
constructor TMultipleMessage.Create(owner:TMoverList; nCont:Integer; x,y:Integer);
begin
  inherited Create(owner);

  FAttr:=maThru;
  NGrade:=nCont;
  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iAnim:=0;
    iShape:=S_MULTI+nCont;
    Visible:=True;
    Z:=Z_TOP;
    AddMode:=False;
  end;

  Self.X:=X;
  Self.Y:=Y;
  FOwner.Spr[mySpr].Pos:=Point(x - SIZE_MULTI[nCont] shr 1, y - 16);

end;


destructor TMultipleMessage.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;


procedure TMultipleMessage.Move(t:Integer);
begin
  inherited;

  if (FOwner.NCalled And 1) = 0 then begin
    FOwner.Spr[mySpr].iAnim:=0;
  end else begin
    FOwner.Spr[mySpr].IAnim:=9;
  end;

  //1.5bŎ
  if AgeT > 90 then
    Die;
end;

procedure TMultipleMessage.OnDie;
begin
  inherited;

  FOwner.Spr[mySpr].Hide;
end;





////////////////////ӂ߂ɂ[
constructor TConfigMenu.Create(owner:TMoverList; Shapes:Array of Integer; posY:Integer);
var
  i:Integer;
  curX:Integer;
begin
  inherited Create(owner);

  Count:=High(Shapes);

  curX:=240+16;  //ŏ̃ACeXW

  if Count = 0 then begin
    //ڂȂȂAZ^O
    MySprs[0]:=FOwner.NewSprite;
    with FOwner.Spr[MySprs[0]] do begin
      iShape:=Shapes[0];
      iAnim:=1;
      MaxAnim:=1;
      MinAnim:=0;
      X:=(640-Width) div 2;
      Y:=posY;
      Show;
    end;

  end else begin

    //ڂȏȂAڂ͉E񂹁A͍
    For i:=0 to Count do begin
      MySprs[i]:=FOwner.NewSprite;
      with FOwner.Spr[MySprs[i]] do begin
        iShape:=Shapes[i];
        iAnim:=1;
        MaxAnim:=1;
        MinAnim:=0;
        if i = 0 then
          X:=240 - Width
        else begin
          X:=curX;
          Inc(curX,Width+16);
        end;
        Y:=posY;
        Show;
      end;
    end;
  end;
end;

destructor TConfigMenu.Destroy;
var
  i:Integer;
begin
  inherited;

  For i:=0 to Count do begin
    FOwner.FreeSprite(MySprs[i]);
  end;

end;

procedure TConfigMenu.OnDie;
var
  i:Integer;
begin
  inherited;

  For i:=0 to Count do
    FOwner.Spr[mySprs[i]].Hide;
end;

procedure TConfigMenu.Move(t:Integer);
var
  i:Integer;
begin
  inherited;

  For i:=1 to Count do begin
    if ItemIndex = i then
      FOwner.Spr[MySprs[i]].IAnim:=0
    else
      FOwner.Spr[MySprs[i]].IAnim:=1;
  end;
end;


//tH[JX킹
procedure TConfigMenu.Focus;
begin
  FFocus:=True;
  FOwner.Spr[MySprs[0]].IAnim:=0;
end;


//tH[JX͂
procedure TConfigMenu.UnFocus;
begin
  FFocus:=False;
  FOwner.Spr[MySprs[0]].IAnim:=1;
end;


//1ŉEIA-1ōI
procedure TConfigMenu.Select(k:Integer);
begin
  Inc(ItemIndex,k);

  if ItemIndex < 1 then
    ItemIndex:=1;
  if ItemIndex > Count then
    ItemIndex:=Count;
end;

//Es̃Zbg
procedure TConfigMenu.SetVisible(v:Boolean);
var
  i:Integer;
begin
  For i:=0 to Count do
    FOwner.Spr[mySprs[i]].Visible:=v;
end;


end.
