unit s_3DNow;

//3DNow! CXgNVgpjbg

interface


var
  _3DNowSupported:Boolean;    //3DNow!T|[gĂ(Initializationŏ)
  MMXSupported:Boolean;       //MMXT|[gĂ(Initializationŏ)


const
// Ql
//
// H Gotou  MMX Pentium Instruction Support Component for Delphi 3
//
// AMD      3DNow! eNmW}jA
//            AMD K6-2 Processor Code Optimization
//            AMD Processor Recognition
//
// 肪Ƃ܂m(__)m






//3D Now
//
//gƂẮA
//
// DW _3DNow
// DB MM0_EAX c Ƃɂ\[XEfXeBl[V̎w
// DB opcode
//
//  ƁAȂBʓ|ȁ`

{$DEFINE MMXONLY}

{$IFNDEF MMXONLY}
  _3DNow    = $0F0F;  //3DNow߂̍ŏ2oCg
  PAVGUSB   = $BF;
  PFADD     = $9E;
  PFSUB     = $9A;
  PFSUBR    = $AA;
  PFACC     = $AE;
  PFCMPGE   = $90;
  PFCMPGT   = $A0;
  PFCMPEQ   = $B0;
  PFMIN     = $94;
  PFMAX     = $A4;
  PI2FD     = $0D;
  PF2ID     = $1D;
  PFRCP     = $96;
  PFRSQRT   = $97;
  PFMUL     = $B4;
  PFRCPIT1  = $A6;
  PFRSQIT1  = $A7;
  PFRCPIT2  = $B6;
  PMULHRW   = $B7;
  FEMMS     = $0E0F;

  //fBXeBl[VWX^ = MM0̂ƂAPREFETCH
  //fBXeBl[VWX^ = MM1̂ƂAPREFETCHWƂ݂Ȃ̂Œ
  PREFETCH  = $0D0F;
  PREFETCHW = $0D0F;
{$ENDIF}

//
  CPUID     = $A20F;
  RDTSC     = $310F;
  RDPMC     = $330F;
//Define MMX Instructions opcode
  EMMS      = $770F;  //Empty MMX state
  MOVD_ld   = $6E0F;  //Move operation
  MOVD_st   = $7E0F;
  MOVQ_ld   = $6F0F;
  MOVQ_st   = $7F0F;
  PAND      = $DB0F;  //Bit operation
  PANDN     = $DF0F;
  POR       = $EB0F;
  PXOR      = $EF0F;
  PSRLw     = $D10F;
  PSRLd     = $D20F;
  PSRLq     = $D30F;
  PSRAw     = $E10F;
  PSRAd     = $E20F;
  PSLLw     = $F10F;
  PSLLd     = $F20F;
  PSLLq     = $F30F;
  PSXXimw   = $710F;
  PSXXimd   = $720F;
  PSXXimq   = $730F;
  PCMPGTb   = $640F;  //Compare data
  PCMPGTw   = $650F;
  PCMPGTd   = $660F;
  PCMPEQb   = $740F;
  PCMPEQw   = $750F;
  PCMPEQd   = $760F;
  PACKSSwb  = $630F;  //Pack data
  PACKSSdw  = $6B0F;
  PACKUSwb  = $670F;
  PUNPCKLbw = $600F;  //Unpack data
  PUNPCKLwd = $610F;
  PUNPCKLdq = $620F;
  PUNPCKHbw = $680F;
  PUNPCKHwd = $690F;
  PUNPCKHdq = $6A0F;
  PADDUSb   = $DC0F;  //Mathematical operation
  PADDUSw   = $DD0F;
  PADDSb    = $EC0F;
  PADDSw    = $ED0F;
  PADDb     = $FC0F;
  PADDw     = $FD0F;
  PADDd     = $FE0F;
  PSUBUSb   = $D80F;
  PSUBUSw   = $D90F;
  PSUBSb    = $E80F;
  PSUBSw    = $E90F;
  PSUBb     = $F80F;
  PSUBw     = $F90F;
  PSUBd     = $FA0F;
  PMULLw    = $D50F;
  PMULHw    = $E50F;
  PMADDwd   = $F50F;






//Define MMX ModR/W for MMX_resisters and General resisters
  MM0_EAX   = ($3 shl 6) + ($0 shl 3) + ($0 shl 0);
  MM1_EAX   = ($3 shl 6) + ($1 shl 3) + ($0 shl 0);
  MM2_EAX   = ($3 shl 6) + ($2 shl 3) + ($0 shl 0);
  MM3_EAX   = ($3 shl 6) + ($3 shl 3) + ($0 shl 0);
  MM4_EAX   = ($3 shl 6) + ($4 shl 3) + ($0 shl 0);
  MM5_EAX   = ($3 shl 6) + ($5 shl 3) + ($0 shl 0);
  MM6_EAX   = ($3 shl 6) + ($6 shl 3) + ($0 shl 0);
  MM7_EAX   = ($3 shl 6) + ($7 shl 3) + ($0 shl 0);
  MM0_ECX   = ($3 shl 6) + ($0 shl 3) + ($1 shl 0);
  MM1_ECX   = ($3 shl 6) + ($1 shl 3) + ($1 shl 0);
  MM2_ECX   = ($3 shl 6) + ($2 shl 3) + ($1 shl 0);
  MM3_ECX   = ($3 shl 6) + ($3 shl 3) + ($1 shl 0);
  MM4_ECX   = ($3 shl 6) + ($4 shl 3) + ($1 shl 0);
  MM5_ECX   = ($3 shl 6) + ($5 shl 3) + ($1 shl 0);
  MM6_ECX   = ($3 shl 6) + ($6 shl 3) + ($1 shl 0);
  MM7_ECX   = ($3 shl 6) + ($7 shl 3) + ($1 shl 0);
  MM0_EDX   = ($3 shl 6) + ($0 shl 3) + ($2 shl 0);
  MM1_EDX   = ($3 shl 6) + ($1 shl 3) + ($2 shl 0);
  MM2_EDX   = ($3 shl 6) + ($2 shl 3) + ($2 shl 0);
  MM3_EDX   = ($3 shl 6) + ($3 shl 3) + ($2 shl 0);
  MM4_EDX   = ($3 shl 6) + ($4 shl 3) + ($2 shl 0);
  MM5_EDX   = ($3 shl 6) + ($5 shl 3) + ($2 shl 0);
  MM6_EDX   = ($3 shl 6) + ($6 shl 3) + ($2 shl 0);
  MM7_EDX   = ($3 shl 6) + ($7 shl 3) + ($2 shl 0);
  MM0_EBX   = ($3 shl 6) + ($0 shl 3) + ($3 shl 0);
  MM1_EBX   = ($3 shl 6) + ($1 shl 3) + ($3 shl 0);
  MM2_EBX   = ($3 shl 6) + ($2 shl 3) + ($3 shl 0);
  MM3_EBX   = ($3 shl 6) + ($3 shl 3) + ($3 shl 0);
  MM4_EBX   = ($3 shl 6) + ($4 shl 3) + ($3 shl 0);
  MM5_EBX   = ($3 shl 6) + ($5 shl 3) + ($3 shl 0);
  MM6_EBX   = ($3 shl 6) + ($6 shl 3) + ($3 shl 0);
  MM7_EBX   = ($3 shl 6) + ($7 shl 3) + ($3 shl 0);
  MM0_ESP   = ($3 shl 6) + ($0 shl 3) + ($4 shl 0);
  MM1_ESP   = ($3 shl 6) + ($1 shl 3) + ($4 shl 0);
  MM2_ESP   = ($3 shl 6) + ($2 shl 3) + ($4 shl 0);
  MM3_ESP   = ($3 shl 6) + ($3 shl 3) + ($4 shl 0);
  MM4_ESP   = ($3 shl 6) + ($4 shl 3) + ($4 shl 0);
  MM5_ESP   = ($3 shl 6) + ($5 shl 3) + ($4 shl 0);
  MM6_ESP   = ($3 shl 6) + ($6 shl 3) + ($4 shl 0);
  MM7_ESP   = ($3 shl 6) + ($7 shl 3) + ($4 shl 0);
  MM0_EBP   = ($3 shl 6) + ($0 shl 3) + ($5 shl 0);
  MM1_EBP   = ($3 shl 6) + ($1 shl 3) + ($5 shl 0);
  MM2_EBP   = ($3 shl 6) + ($2 shl 3) + ($5 shl 0);
  MM3_EBP   = ($3 shl 6) + ($3 shl 3) + ($5 shl 0);
  MM4_EBP   = ($3 shl 6) + ($4 shl 3) + ($5 shl 0);
  MM5_EBP   = ($3 shl 6) + ($5 shl 3) + ($5 shl 0);
  MM6_EBP   = ($3 shl 6) + ($6 shl 3) + ($5 shl 0);
  MM7_EBP   = ($3 shl 6) + ($7 shl 3) + ($5 shl 0);
  MM0_ESI   = ($3 shl 6) + ($0 shl 3) + ($6 shl 0);
  MM1_ESI   = ($3 shl 6) + ($1 shl 3) + ($6 shl 0);
  MM2_ESI   = ($3 shl 6) + ($2 shl 3) + ($6 shl 0);
  MM3_ESI   = ($3 shl 6) + ($3 shl 3) + ($6 shl 0);
  MM4_ESI   = ($3 shl 6) + ($4 shl 3) + ($6 shl 0);
  MM5_ESI   = ($3 shl 6) + ($5 shl 3) + ($6 shl 0);
  MM6_ESI   = ($3 shl 6) + ($6 shl 3) + ($6 shl 0);
  MM7_ESI   = ($3 shl 6) + ($7 shl 3) + ($6 shl 0);
  MM0_EDI   = ($3 shl 6) + ($0 shl 3) + ($7 shl 0);
  MM1_EDI   = ($3 shl 6) + ($1 shl 3) + ($7 shl 0);
  MM2_EDI   = ($3 shl 6) + ($2 shl 3) + ($7 shl 0);
  MM3_EDI   = ($3 shl 6) + ($3 shl 3) + ($7 shl 0);
  MM4_EDI   = ($3 shl 6) + ($4 shl 3) + ($7 shl 0);
  MM5_EDI   = ($3 shl 6) + ($5 shl 3) + ($7 shl 0);
  MM6_EDI   = ($3 shl 6) + ($6 shl 3) + ($7 shl 0);
  MM7_EDI   = ($3 shl 6) + ($7 shl 3) + ($7 shl 0);

//Define MMX ModR/W for MMX_resisters operation
  MM0_MM0   = ($3 shl 6) + ($0 shl 3) + ($0 shl 0);
  MM1_MM0   = ($3 shl 6) + ($1 shl 3) + ($0 shl 0);
  MM2_MM0   = ($3 shl 6) + ($2 shl 3) + ($0 shl 0);
  MM3_MM0   = ($3 shl 6) + ($3 shl 3) + ($0 shl 0);
  MM4_MM0   = ($3 shl 6) + ($4 shl 3) + ($0 shl 0);
  MM5_MM0   = ($3 shl 6) + ($5 shl 3) + ($0 shl 0);
  MM6_MM0   = ($3 shl 6) + ($6 shl 3) + ($0 shl 0);
  MM7_MM0   = ($3 shl 6) + ($7 shl 3) + ($0 shl 0);
  MM0_MM1   = ($3 shl 6) + ($0 shl 3) + ($1 shl 0);
  MM1_MM1   = ($3 shl 6) + ($1 shl 3) + ($1 shl 0);
  MM2_MM1   = ($3 shl 6) + ($2 shl 3) + ($1 shl 0);
  MM3_MM1   = ($3 shl 6) + ($3 shl 3) + ($1 shl 0);
  MM4_MM1   = ($3 shl 6) + ($4 shl 3) + ($1 shl 0);
  MM5_MM1   = ($3 shl 6) + ($5 shl 3) + ($1 shl 0);
  MM6_MM1   = ($3 shl 6) + ($6 shl 3) + ($1 shl 0);
  MM7_MM1   = ($3 shl 6) + ($7 shl 3) + ($1 shl 0);
  MM0_MM2   = ($3 shl 6) + ($0 shl 3) + ($2 shl 0);
  MM1_MM2   = ($3 shl 6) + ($1 shl 3) + ($2 shl 0);
  MM2_MM2   = ($3 shl 6) + ($2 shl 3) + ($2 shl 0);
  MM3_MM2   = ($3 shl 6) + ($3 shl 3) + ($2 shl 0);
  MM4_MM2   = ($3 shl 6) + ($4 shl 3) + ($2 shl 0);
  MM5_MM2   = ($3 shl 6) + ($5 shl 3) + ($2 shl 0);
  MM6_MM2   = ($3 shl 6) + ($6 shl 3) + ($2 shl 0);
  MM7_MM2   = ($3 shl 6) + ($7 shl 3) + ($2 shl 0);
  MM0_MM3   = ($3 shl 6) + ($0 shl 3) + ($3 shl 0);
  MM1_MM3   = ($3 shl 6) + ($1 shl 3) + ($3 shl 0);
  MM2_MM3   = ($3 shl 6) + ($2 shl 3) + ($3 shl 0);
  MM3_MM3   = ($3 shl 6) + ($3 shl 3) + ($3 shl 0);
  MM4_MM3   = ($3 shl 6) + ($4 shl 3) + ($3 shl 0);
  MM5_MM3   = ($3 shl 6) + ($5 shl 3) + ($3 shl 0);
  MM6_MM3   = ($3 shl 6) + ($6 shl 3) + ($3 shl 0);
  MM7_MM3   = ($3 shl 6) + ($7 shl 3) + ($3 shl 0);
  MM0_MM4   = ($3 shl 6) + ($0 shl 3) + ($4 shl 0);
  MM1_MM4   = ($3 shl 6) + ($1 shl 3) + ($4 shl 0);
  MM2_MM4   = ($3 shl 6) + ($2 shl 3) + ($4 shl 0);
  MM3_MM4   = ($3 shl 6) + ($3 shl 3) + ($4 shl 0);
  MM4_MM4   = ($3 shl 6) + ($4 shl 3) + ($4 shl 0);
  MM5_MM4   = ($3 shl 6) + ($5 shl 3) + ($4 shl 0);
  MM6_MM4   = ($3 shl 6) + ($6 shl 3) + ($4 shl 0);
  MM7_MM4   = ($3 shl 6) + ($7 shl 3) + ($4 shl 0);
  MM0_MM5   = ($3 shl 6) + ($0 shl 3) + ($5 shl 0);
  MM1_MM5   = ($3 shl 6) + ($1 shl 3) + ($5 shl 0);
  MM2_MM5   = ($3 shl 6) + ($2 shl 3) + ($5 shl 0);
  MM3_MM5   = ($3 shl 6) + ($3 shl 3) + ($5 shl 0);
  MM4_MM5   = ($3 shl 6) + ($4 shl 3) + ($5 shl 0);
  MM5_MM5   = ($3 shl 6) + ($5 shl 3) + ($5 shl 0);
  MM6_MM5   = ($3 shl 6) + ($6 shl 3) + ($5 shl 0);
  MM7_MM5   = ($3 shl 6) + ($7 shl 3) + ($5 shl 0);
  MM0_MM6   = ($3 shl 6) + ($0 shl 3) + ($6 shl 0);
  MM1_MM6   = ($3 shl 6) + ($1 shl 3) + ($6 shl 0);
  MM2_MM6   = ($3 shl 6) + ($2 shl 3) + ($6 shl 0);
  MM3_MM6   = ($3 shl 6) + ($3 shl 3) + ($6 shl 0);
  MM4_MM6   = ($3 shl 6) + ($4 shl 3) + ($6 shl 0);
  MM5_MM6   = ($3 shl 6) + ($5 shl 3) + ($6 shl 0);
  MM6_MM6   = ($3 shl 6) + ($6 shl 3) + ($6 shl 0);
  MM7_MM6   = ($3 shl 6) + ($7 shl 3) + ($6 shl 0);
  MM0_MM7   = ($3 shl 6) + ($0 shl 3) + ($7 shl 0);
  MM1_MM7   = ($3 shl 6) + ($1 shl 3) + ($7 shl 0);
  MM2_MM7   = ($3 shl 6) + ($2 shl 3) + ($7 shl 0);
  MM3_MM7   = ($3 shl 6) + ($3 shl 3) + ($7 shl 0);
  MM4_MM7   = ($3 shl 6) + ($4 shl 3) + ($7 shl 0);
  MM5_MM7   = ($3 shl 6) + ($5 shl 3) + ($7 shl 0);
  MM6_MM7   = ($3 shl 6) + ($6 shl 3) + ($7 shl 0);
  MM7_MM7   = ($3 shl 6) + ($7 shl 3) + ($7 shl 0);

//Define MMX ModR/W for MMX_resisters and memory operation /w General resisters
  MM0_mEAX  = ($0 shl 6) + ($0 shl 3) + ($0 shl 0);
  MM1_mEAX  = ($0 shl 6) + ($1 shl 3) + ($0 shl 0);
  MM2_mEAX  = ($0 shl 6) + ($2 shl 3) + ($0 shl 0);
  MM3_mEAX  = ($0 shl 6) + ($3 shl 3) + ($0 shl 0);
  MM4_mEAX  = ($0 shl 6) + ($4 shl 3) + ($0 shl 0);
  MM5_mEAX  = ($0 shl 6) + ($5 shl 3) + ($0 shl 0);
  MM6_mEAX  = ($0 shl 6) + ($6 shl 3) + ($0 shl 0);
  MM7_mEAX  = ($0 shl 6) + ($7 shl 3) + ($0 shl 0);
  MM0_mECX  = ($0 shl 6) + ($0 shl 3) + ($1 shl 0);
  MM1_mECX  = ($0 shl 6) + ($1 shl 3) + ($1 shl 0);
  MM2_mECX  = ($0 shl 6) + ($2 shl 3) + ($1 shl 0);
  MM3_mECX  = ($0 shl 6) + ($3 shl 3) + ($1 shl 0);
  MM4_mECX  = ($0 shl 6) + ($4 shl 3) + ($1 shl 0);
  MM5_mECX  = ($0 shl 6) + ($5 shl 3) + ($1 shl 0);
  MM6_mECX  = ($0 shl 6) + ($6 shl 3) + ($1 shl 0);
  MM7_mECX  = ($0 shl 6) + ($7 shl 3) + ($1 shl 0);
  MM0_mEDX  = ($0 shl 6) + ($0 shl 3) + ($2 shl 0);
  MM1_mEDX  = ($0 shl 6) + ($1 shl 3) + ($2 shl 0);
  MM2_mEDX  = ($0 shl 6) + ($2 shl 3) + ($2 shl 0);
  MM3_mEDX  = ($0 shl 6) + ($3 shl 3) + ($2 shl 0);
  MM4_mEDX  = ($0 shl 6) + ($4 shl 3) + ($2 shl 0);
  MM5_mEDX  = ($0 shl 6) + ($5 shl 3) + ($2 shl 0);
  MM6_mEDX  = ($0 shl 6) + ($6 shl 3) + ($2 shl 0);
  MM7_mEDX  = ($0 shl 6) + ($7 shl 3) + ($2 shl 0);
  MM0_mEBX  = ($0 shl 6) + ($0 shl 3) + ($3 shl 0);
  MM1_mEBX  = ($0 shl 6) + ($1 shl 3) + ($3 shl 0);
  MM2_mEBX  = ($0 shl 6) + ($2 shl 3) + ($3 shl 0);
  MM3_mEBX  = ($0 shl 6) + ($3 shl 3) + ($3 shl 0);
  MM4_mEBX  = ($0 shl 6) + ($4 shl 3) + ($3 shl 0);
  MM5_mEBX  = ($0 shl 6) + ($5 shl 3) + ($3 shl 0);
  MM6_mEBX  = ($0 shl 6) + ($6 shl 3) + ($3 shl 0);
  MM7_mEBX  = ($0 shl 6) + ($7 shl 3) + ($3 shl 0);
  MM0_mESI  = ($0 shl 6) + ($0 shl 3) + ($6 shl 0);
  MM1_mESI  = ($0 shl 6) + ($1 shl 3) + ($6 shl 0);
  MM2_mESI  = ($0 shl 6) + ($2 shl 3) + ($6 shl 0);
  MM3_mESI  = ($0 shl 6) + ($3 shl 3) + ($6 shl 0);
  MM4_mESI  = ($0 shl 6) + ($4 shl 3) + ($6 shl 0);
  MM5_mESI  = ($0 shl 6) + ($5 shl 3) + ($6 shl 0);
  MM6_mESI  = ($0 shl 6) + ($6 shl 3) + ($6 shl 0);
  MM7_mESI  = ($0 shl 6) + ($7 shl 3) + ($6 shl 0);
  MM0_mEDI  = ($0 shl 6) + ($0 shl 3) + ($7 shl 0);
  MM1_mEDI  = ($0 shl 6) + ($1 shl 3) + ($7 shl 0);
  MM2_mEDI  = ($0 shl 6) + ($2 shl 3) + ($7 shl 0);
  MM3_mEDI  = ($0 shl 6) + ($3 shl 3) + ($7 shl 0);
  MM4_mEDI  = ($0 shl 6) + ($4 shl 3) + ($7 shl 0);
  MM5_mEDI  = ($0 shl 6) + ($5 shl 3) + ($7 shl 0);
  MM6_mEDI  = ($0 shl 6) + ($6 shl 3) + ($7 shl 0);
  MM7_mEDI  = ($0 shl 6) + ($7 shl 3) + ($7 shl 0);

//MMXWX^Ԃ̓]pc DB MM0_m ̌ɁA DD AhX
  MM0_m     = ($0 shl 6) + ($0 shl 3) + ($5 shl 0);
  MM1_m     = ($0 shl 6) + ($1 shl 3) + ($5 shl 0);
  MM2_m     = ($0 shl 6) + ($2 shl 3) + ($5 shl 0);
  MM3_m     = ($0 shl 6) + ($3 shl 3) + ($5 shl 0);
  MM4_m     = ($0 shl 6) + ($4 shl 3) + ($5 shl 0);
  MM5_m     = ($0 shl 6) + ($5 shl 3) + ($5 shl 0);
  MM6_m     = ($0 shl 6) + ($6 shl 3) + ($5 shl 0);
  MM7_m     = ($0 shl 6) + ($7 shl 3) + ($5 shl 0);

//x[X + CfNX@c DB MM0_bEAX ̌ɁA DB CfNX
  MM0_bEAX  = ($1 shl 6) + ($0 shl 3) + ($0 shl 0);
  MM1_bEAX  = ($1 shl 6) + ($1 shl 3) + ($0 shl 0);
  MM2_bEAX  = ($1 shl 6) + ($2 shl 3) + ($0 shl 0);
  MM3_bEAX  = ($1 shl 6) + ($3 shl 3) + ($0 shl 0);
  MM4_bEAX  = ($1 shl 6) + ($4 shl 3) + ($0 shl 0);
  MM5_bEAX  = ($1 shl 6) + ($5 shl 3) + ($0 shl 0);
  MM6_bEAX  = ($1 shl 6) + ($6 shl 3) + ($0 shl 0);
  MM7_bEAX  = ($1 shl 6) + ($7 shl 3) + ($0 shl 0);
  MM0_bECX  = ($1 shl 6) + ($0 shl 3) + ($1 shl 0);
  MM1_bECX  = ($1 shl 6) + ($1 shl 3) + ($1 shl 0);
  MM2_bECX  = ($1 shl 6) + ($2 shl 3) + ($1 shl 0);
  MM3_bECX  = ($1 shl 6) + ($3 shl 3) + ($1 shl 0);
  MM4_bECX  = ($1 shl 6) + ($4 shl 3) + ($1 shl 0);
  MM5_bECX  = ($1 shl 6) + ($5 shl 3) + ($1 shl 0);
  MM6_bECX  = ($1 shl 6) + ($6 shl 3) + ($1 shl 0);
  MM7_bECX  = ($1 shl 6) + ($7 shl 3) + ($1 shl 0);
  MM0_bEDX  = ($1 shl 6) + ($0 shl 3) + ($2 shl 0);
  MM1_bEDX  = ($1 shl 6) + ($1 shl 3) + ($2 shl 0);
  MM2_bEDX  = ($1 shl 6) + ($2 shl 3) + ($2 shl 0);
  MM3_bEDX  = ($1 shl 6) + ($3 shl 3) + ($2 shl 0);
  MM4_bEDX  = ($1 shl 6) + ($4 shl 3) + ($2 shl 0);
  MM5_bEDX  = ($1 shl 6) + ($5 shl 3) + ($2 shl 0);
  MM6_bEDX  = ($1 shl 6) + ($6 shl 3) + ($2 shl 0);
  MM7_bEDX  = ($1 shl 6) + ($7 shl 3) + ($2 shl 0);
  MM0_bEBX  = ($1 shl 6) + ($0 shl 3) + ($3 shl 0);
  MM1_bEBX  = ($1 shl 6) + ($1 shl 3) + ($3 shl 0);
  MM2_bEBX  = ($1 shl 6) + ($2 shl 3) + ($3 shl 0);
  MM3_bEBX  = ($1 shl 6) + ($3 shl 3) + ($3 shl 0);
  MM4_bEBX  = ($1 shl 6) + ($4 shl 3) + ($3 shl 0);
  MM5_bEBX  = ($1 shl 6) + ($5 shl 3) + ($3 shl 0);
  MM6_bEBX  = ($1 shl 6) + ($6 shl 3) + ($3 shl 0);
  MM7_bEBX  = ($1 shl 6) + ($7 shl 3) + ($3 shl 0);
  MM0_bEBP  = ($1 shl 6) + ($0 shl 3) + ($5 shl 0);
  MM1_bEBP  = ($1 shl 6) + ($1 shl 3) + ($5 shl 0);
  MM2_bEBP  = ($1 shl 6) + ($2 shl 3) + ($5 shl 0);
  MM3_bEBP  = ($1 shl 6) + ($3 shl 3) + ($5 shl 0);
  MM4_bEBP  = ($1 shl 6) + ($4 shl 3) + ($5 shl 0);
  MM5_bEBP  = ($1 shl 6) + ($5 shl 3) + ($5 shl 0);
  MM6_bEBP  = ($1 shl 6) + ($6 shl 3) + ($5 shl 0);
  MM7_bEBP  = ($1 shl 6) + ($7 shl 3) + ($5 shl 0);
  MM0_bESI  = ($1 shl 6) + ($0 shl 3) + ($6 shl 0);
  MM1_bESI  = ($1 shl 6) + ($1 shl 3) + ($6 shl 0);
  MM2_bESI  = ($1 shl 6) + ($2 shl 3) + ($6 shl 0);
  MM3_bESI  = ($1 shl 6) + ($3 shl 3) + ($6 shl 0);
  MM4_bESI  = ($1 shl 6) + ($4 shl 3) + ($6 shl 0);
  MM5_bESI  = ($1 shl 6) + ($5 shl 3) + ($6 shl 0);
  MM6_bESI  = ($1 shl 6) + ($6 shl 3) + ($6 shl 0);
  MM7_bESI  = ($1 shl 6) + ($7 shl 3) + ($6 shl 0);
  MM0_bEDI  = ($1 shl 6) + ($0 shl 3) + ($7 shl 0);
  MM1_bEDI  = ($1 shl 6) + ($1 shl 3) + ($7 shl 0);
  MM2_bEDI  = ($1 shl 6) + ($2 shl 3) + ($7 shl 0);
  MM3_bEDI  = ($1 shl 6) + ($3 shl 3) + ($7 shl 0);
  MM4_bEDI  = ($1 shl 6) + ($4 shl 3) + ($7 shl 0);
  MM5_bEDI  = ($1 shl 6) + ($5 shl 3) + ($7 shl 0);
  MM6_bEDI  = ($1 shl 6) + ($6 shl 3) + ($7 shl 0);
  MM7_bEDI  = ($1 shl 6) + ($7 shl 3) + ($7 shl 0);


//2oCg^CvAhXw

//32rbgfBXv[Xg
// DB MMn_2n;  DB bEAX_iECX_4; Ƃ悤ɎgB
  MM0_2n = ($0 shl 3) + 4;
  MM1_2n = ($1 shl 3) + 4;
  MM2_2n = ($2 shl 3) + 4;
  MM3_2n = ($3 shl 3) + 4;
  MM4_2n = ($4 shl 3) + 4;
  MM5_2n = ($5 shl 3) + 4;
  MM6_2n = ($6 shl 3) + 4;
  MM7_2n = ($7 shl 3) + 4;

//32rbgfBXv[Xg
// DB MMn_2;  DB bEAX_iECX_4; DD AhX Ƃ悤ɎgB
  MM0_2 = ($1 shl 6) + ($0 shl 3) + 4;
  MM1_2 = ($1 shl 6) + ($1 shl 3) + 4;
  MM2_2 = ($1 shl 6) + ($2 shl 3) + 4;
  MM3_2 = ($1 shl 6) + ($3 shl 3) + 4;
  MM4_2 = ($1 shl 6) + ($4 shl 3) + 4;
  MM5_2 = ($1 shl 6) + ($5 shl 3) + 4;
  MM6_2 = ($1 shl 6) + ($6 shl 3) + 4;
  MM7_2 = ($1 shl 6) + ($7 shl 3) + 4;


//x[XECfNXEXP[t@N^̎w
  bEAX_iEAX = ($0 shl 3) + $0;  bEAX_iECX = ($1 shl 3) + $0;  bEAX_iEDX = ($2 shl 3) + $0;  bEAX_iEBX = ($3 shl 3) + $0;
  bEAX_iESP = ($4 shl 3) + $0;  bEAX_iEBP = ($5 shl 3) + $0;  bEAX_iESI = ($6 shl 3) + $0;  bEAX_iEDI = ($7 shl 3) + $0;

  bECX_iEAX = ($0 shl 3) + $1;  bECX_iECX = ($1 shl 3) + $1;  bECX_iEDX = ($2 shl 3) + $1;  bECX_iEBX = ($3 shl 3) + $1;
  bECX_iESP = ($4 shl 3) + $1;  bECX_iEBP = ($5 shl 3) + $1;  bECX_iESI = ($6 shl 3) + $1;  bECX_iEDI = ($7 shl 3) + $1;

  bEDX_iEAX = ($0 shl 3) + $2;  bEDX_iECX = ($1 shl 3) + $2;  bEDX_iEDX = ($2 shl 3) + $2;  bEDX_iEBX = ($3 shl 3) + $2;
  bEDX_iESP = ($4 shl 3) + $2;  bEDX_iEBP = ($5 shl 3) + $2;  bEDX_iESI = ($6 shl 3) + $2;  bEDX_iEDI = ($7 shl 3) + $2;

  bEBX_iEAX = ($0 shl 3) + $3;  bEBX_iECX = ($1 shl 3) + $3;  bEBX_iEDX = ($2 shl 3) + $3;  bEBX_iEBX = ($3 shl 3) + $3;
  bEBX_iESP = ($4 shl 3) + $3;  bEBX_iEBP = ($5 shl 3) + $3;  bEBX_iESI = ($6 shl 3) + $3;  bEBX_iEDI = ($7 shl 3) + $3;

  bESP_iEAX = ($0 shl 3) + $4;  bESP_iECX = ($1 shl 3) + $4;  bESP_iEDX = ($2 shl 3) + $4;  bESP_iEBX = ($3 shl 3) + $4;
  bESP_iESP = ($4 shl 3) + $4;  bESP_iEBP = ($5 shl 3) + $4;  bESP_iESI = ($6 shl 3) + $4;  bESP_iEDI = ($7 shl 3) + $4;

  bEBP_iEAX = ($0 shl 3) + $5;  bEBP_iECX = ($1 shl 3) + $5;  bEBP_iEDX = ($2 shl 3) + $5;  bEBP_iEBX = ($3 shl 3) + $5;
  bEBP_iESP = ($4 shl 3) + $5;  bEBP_iEBP = ($5 shl 3) + $5;  bEBP_iESI = ($6 shl 3) + $5;  bEBP_iEDI = ($7 shl 3) + $5;

  bESI_iEAX = ($0 shl 3) + $6;  bESI_iECX = ($1 shl 3) + $6;  bESI_iEDX = ($2 shl 3) + $6;  bESI_iEBX = ($3 shl 3) + $6;
  bESI_iESP = ($4 shl 3) + $6;  bESI_iEBP = ($5 shl 3) + $6;  bESI_iESI = ($6 shl 3) + $6;  bESI_iEDI = ($7 shl 3) + $6;

  bEDI_iEAX = ($0 shl 3) + $7;  bEDI_iECX = ($1 shl 3) + $7;  bEDI_iEDX = ($2 shl 3) + $7;  bEDI_iEBX = ($3 shl 3) + $7;
  bEDI_iESP = ($4 shl 3) + $7;  bEDI_iEBP = ($5 shl 3) + $7;  bEDI_iESI = ($6 shl 3) + $7;  bEDI_iEDI = ($7 shl 3) + $7;


  bEAX_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $0;  bEAX_iECX_2 = ($1 shl 6) + ($1 shl 3) + $0;  bEAX_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $0;  bEAX_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $0;
  bEAX_iESP_2 = ($1 shl 6) + ($4 shl 3) + $0;  bEAX_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $0;  bEAX_iESI_2 = ($1 shl 6) + ($6 shl 3) + $0;  bEAX_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $0;

  bECX_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $1;  bECX_iECX_2 = ($1 shl 6) + ($1 shl 3) + $1;  bECX_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $1;  bECX_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $1;
  bECX_iESP_2 = ($1 shl 6) + ($4 shl 3) + $1;  bECX_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $1;  bECX_iESI_2 = ($1 shl 6) + ($6 shl 3) + $1;  bECX_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $1;

  bEDX_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $2;  bEDX_iECX_2 = ($1 shl 6) + ($1 shl 3) + $2;  bEDX_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $2;  bEDX_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $2;
  bEDX_iESP_2 = ($1 shl 6) + ($4 shl 3) + $2;  bEDX_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $2;  bEDX_iESI_2 = ($1 shl 6) + ($6 shl 3) + $2;  bEDX_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $2;

  bEBX_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $3;  bEBX_iECX_2 = ($1 shl 6) + ($1 shl 3) + $3;  bEBX_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $3;  bEBX_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $3;
  bEBX_iESP_2 = ($1 shl 6) + ($4 shl 3) + $3;  bEBX_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $3;  bEBX_iESI_2 = ($1 shl 6) + ($6 shl 3) + $3;  bEBX_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $3;

  bESP_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $4;  bESP_iECX_2 = ($1 shl 6) + ($1 shl 3) + $4;  bESP_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $4;  bESP_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $4;
  bESP_iESP_2 = ($1 shl 6) + ($4 shl 3) + $4;  bESP_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $4;  bESP_iESI_2 = ($1 shl 6) + ($6 shl 3) + $4;  bESP_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $4;

  bEBP_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $5;  bEBP_iECX_2 = ($1 shl 6) + ($1 shl 3) + $5;  bEBP_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $5;  bEBP_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $5;
  bEBP_iESP_2 = ($1 shl 6) + ($4 shl 3) + $5;  bEBP_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $5;  bEBP_iESI_2 = ($1 shl 6) + ($6 shl 3) + $5;  bEBP_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $5;

  bESI_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $6;  bESI_iECX_2 = ($1 shl 6) + ($1 shl 3) + $6;  bESI_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $6;  bESI_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $6;
  bESI_iESP_2 = ($1 shl 6) + ($4 shl 3) + $6;  bESI_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $6;  bESI_iESI_2 = ($1 shl 6) + ($6 shl 3) + $6;  bESI_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $6;

  bEDI_iEAX_2 = ($1 shl 6) + ($0 shl 3) + $7;  bEDI_iECX_2 = ($1 shl 6) + ($1 shl 3) + $7;  bEDI_iEDX_2 = ($1 shl 6) + ($2 shl 3) + $7;  bEDI_iEBX_2 = ($1 shl 6) + ($3 shl 3) + $7;
  bEDI_iESP_2 = ($1 shl 6) + ($4 shl 3) + $7;  bEDI_iEBP_2 = ($1 shl 6) + ($5 shl 3) + $7;  bEDI_iESI_2 = ($1 shl 6) + ($6 shl 3) + $7;  bEDI_iEDI_2 = ($1 shl 6) + ($7 shl 3) + $7;


  bEAX_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $0;  bEAX_iECX_4 = ($2 shl 6) + ($1 shl 3) + $0;  bEAX_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $0;  bEAX_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $0;
  bEAX_iESP_4 = ($2 shl 6) + ($4 shl 3) + $0;  bEAX_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $0;  bEAX_iESI_4 = ($2 shl 6) + ($6 shl 3) + $0;  bEAX_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $0;

  bECX_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $1;  bECX_iECX_4 = ($2 shl 6) + ($1 shl 3) + $1;  bECX_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $1;  bECX_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $1;
  bECX_iESP_4 = ($2 shl 6) + ($4 shl 3) + $1;  bECX_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $1;  bECX_iESI_4 = ($2 shl 6) + ($6 shl 3) + $1;  bECX_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $1;

  bEDX_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $2;  bEDX_iECX_4 = ($2 shl 6) + ($1 shl 3) + $2;  bEDX_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $2;  bEDX_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $2;
  bEDX_iESP_4 = ($2 shl 6) + ($4 shl 3) + $2;  bEDX_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $2;  bEDX_iESI_4 = ($2 shl 6) + ($6 shl 3) + $2;  bEDX_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $2;

  bEBX_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $3;  bEBX_iECX_4 = ($2 shl 6) + ($1 shl 3) + $3;  bEBX_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $3;  bEBX_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $3;
  bEBX_iESP_4 = ($2 shl 6) + ($4 shl 3) + $3;  bEBX_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $3;  bEBX_iESI_4 = ($2 shl 6) + ($6 shl 3) + $3;  bEBX_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $3;

  bESP_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $4;  bESP_iECX_4 = ($2 shl 6) + ($1 shl 3) + $4;  bESP_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $4;  bESP_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $4;
  bESP_iESP_4 = ($2 shl 6) + ($4 shl 3) + $4;  bESP_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $4;  bESP_iESI_4 = ($2 shl 6) + ($6 shl 3) + $4;  bESP_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $4;

  bEBP_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $5;  bEBP_iECX_4 = ($2 shl 6) + ($1 shl 3) + $5;  bEBP_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $5;  bEBP_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $5;
  bEBP_iESP_4 = ($2 shl 6) + ($4 shl 3) + $5;  bEBP_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $5;  bEBP_iESI_4 = ($2 shl 6) + ($6 shl 3) + $5;  bEBP_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $5;

  bESI_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $6;  bESI_iECX_4 = ($2 shl 6) + ($1 shl 3) + $6;  bESI_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $6;  bESI_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $6;
  bESI_iESP_4 = ($2 shl 6) + ($4 shl 3) + $6;  bESI_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $6;  bESI_iESI_4 = ($2 shl 6) + ($6 shl 3) + $6;  bESI_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $6;

  bEDI_iEAX_4 = ($2 shl 6) + ($0 shl 3) + $7;  bEDI_iECX_4 = ($2 shl 6) + ($1 shl 3) + $7;  bEDI_iEDX_4 = ($2 shl 6) + ($2 shl 3) + $7;  bEDI_iEBX_4 = ($2 shl 6) + ($3 shl 3) + $7;
  bEDI_iESP_4 = ($2 shl 6) + ($4 shl 3) + $7;  bEDI_iEBP_4 = ($2 shl 6) + ($5 shl 3) + $7;  bEDI_iESI_4 = ($2 shl 6) + ($6 shl 3) + $7;  bEDI_iEDI_4 = ($2 shl 6) + ($7 shl 3) + $7;


  bEAX_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $0;  bEAX_iECX_8 = ($3 shl 6) + ($1 shl 3) + $0;  bEAX_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $0;  bEAX_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $0;
  bEAX_iESP_8 = ($3 shl 6) + ($4 shl 3) + $0;  bEAX_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $0;  bEAX_iESI_8 = ($3 shl 6) + ($6 shl 3) + $0;  bEAX_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $0;

  bECX_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $1;  bECX_iECX_8 = ($3 shl 6) + ($1 shl 3) + $1;  bECX_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $1;  bECX_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $1;
  bECX_iESP_8 = ($3 shl 6) + ($4 shl 3) + $1;  bECX_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $1;  bECX_iESI_8 = ($3 shl 6) + ($6 shl 3) + $1;  bECX_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $1;

  bEDX_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $2;  bEDX_iECX_8 = ($3 shl 6) + ($1 shl 3) + $2;  bEDX_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $2;  bEDX_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $2;
  bEDX_iESP_8 = ($3 shl 6) + ($4 shl 3) + $2;  bEDX_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $2;  bEDX_iESI_8 = ($3 shl 6) + ($6 shl 3) + $2;  bEDX_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $2;

  bEBX_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $3;  bEBX_iECX_8 = ($3 shl 6) + ($1 shl 3) + $3;  bEBX_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $3;  bEBX_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $3;
  bEBX_iESP_8 = ($3 shl 6) + ($4 shl 3) + $3;  bEBX_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $3;  bEBX_iESI_8 = ($3 shl 6) + ($6 shl 3) + $3;  bEBX_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $3;

  bESP_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $4;  bESP_iECX_8 = ($3 shl 6) + ($1 shl 3) + $4;  bESP_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $4;  bESP_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $4;
  bESP_iESP_8 = ($3 shl 6) + ($4 shl 3) + $4;  bESP_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $4;  bESP_iESI_8 = ($3 shl 6) + ($6 shl 3) + $4;  bESP_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $4;

  bEBP_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $5;  bEBP_iECX_8 = ($3 shl 6) + ($1 shl 3) + $5;  bEBP_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $5;  bEBP_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $5;
  bEBP_iESP_8 = ($3 shl 6) + ($4 shl 3) + $5;  bEBP_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $5;  bEBP_iESI_8 = ($3 shl 6) + ($6 shl 3) + $5;  bEBP_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $5;

  bESI_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $6;  bESI_iECX_8 = ($3 shl 6) + ($1 shl 3) + $6;  bESI_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $6;  bESI_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $6;
  bESI_iESP_8 = ($3 shl 6) + ($4 shl 3) + $6;  bESI_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $6;  bESI_iESI_8 = ($3 shl 6) + ($6 shl 3) + $6;  bESI_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $6;

  bEDI_iEAX_8 = ($3 shl 6) + ($0 shl 3) + $7;  bEDI_iECX_8 = ($3 shl 6) + ($1 shl 3) + $7;  bEDI_iEDX_8 = ($3 shl 6) + ($2 shl 3) + $7;  bEDI_iEBX_8 = ($3 shl 6) + ($3 shl 3) + $7;
  bEDI_iESP_8 = ($3 shl 6) + ($4 shl 3) + $7;  bEDI_iEBP_8 = ($3 shl 6) + ($5 shl 3) + $7;  bEDI_iESI_8 = ($3 shl 6) + ($6 shl 3) + $7;  bEDI_iEDI_8 = ($3 shl 6) + ($7 shl 3) + $7;


//define PSXX operand for MMX resister and imm8 data
  MM0_SRLim = $D0;
  MM1_SRLim = $D1;
  MM2_SRLim = $D2;
  MM3_SRLim = $D3;
  MM4_SRLim = $D4;
  MM5_SRLim = $D5;
  MM6_SRLim = $D6;
  MM7_SRLim = $D7;
  MM0_SLLim = $F0;
  MM1_SLLim = $F1;
  MM2_SLLim = $F2;
  MM3_SLLim = $F3;
  MM4_SLLim = $F4;
  MM5_SLLim = $F5;
  MM6_SLLim = $F6;
  MM7_SLLim = $F7;
  MM0_SRAim = $E0;
  MM1_SRAim = $E1;
  MM2_SRAim = $E2;
  MM3_SRAim = $E3;
  MM4_SRAim = $E4;
  MM5_SRAim = $E5;
  MM6_SRAim = $E6;
  MM7_SRAim = $E7;
//***omitted using SIB mode and disp8(xx), disp32(xx)



implementation


procedure s_3DNow_CheckCPUFlags;
begin
  //MMX,3DNowT|[gĂ邩cAMDProcessorRecognitionp
  asm
    pushfd                // save EFLAGS
    pop   eax             // store EFLAGS in EAX
    mov   ebx, eax        // save in EBX for later testing
    xor   eax, $00200000  // toggle bit 21
    push  eax             // put to stack
    popfd                 // save changed EAX to EFLAGS
    pushfd                // push EFLAGS to TOS
    pop   eax             // store EFLAGS in EAX
    cmp   eax, ebx        // see if bit 21 has changed
    jz    @NO_MMX         // if no change, no CPUID


    mov   edx, 0;         // clear edx
    mov   eax, 1;         // setup function #1
    DW    $A20F;
    test  edx, $00800000  // test bit 23(MMX)
    jz    @NO_MMX         // MMX is not supported

    mov   edx,0;
    mov   eax, $80000001  // setup extended function 1
    DW    $A20F           // call the function(CPUID)
    test  edx, $80000000  // test bit 31(3DNow)
    jz    @NO_3DNow       // 3DNow! technology is not supported

    mov   MMXSupported,True;
    mov   _3DNowSupported,True;
    jmp   @END            // 3DNow! is supported.


    @NO_3DNOW:
    mov   MMXSupported,True;
    mov   _3DNowSupported,False;
    jmp   @END            // MMX is supported, but no 3DNow!

    @NO_MMX:
    mov   MMXSupported,False;
    mov   _3DNowSupported,False;

    @END:
  end;
end;

initialization

  s_3DNow_CheckCPUFlags;

end.
