unit splashWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ddsd, defs, SE;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private 錾 }
    FAtFirst:Boolean;
  public
    { Public 錾 }
  end;

var
  Form2: TForm2;

implementation

uses Shooter1;

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
var
  R:TSearchRec;
  ret:Integer;
begin
  FAtFirst:=True;

  {
  //vCf[^R{{bNXɕ\
  if FindFirst(REPLAYPATH+'*.rp',faArchive,R) = 0 then begin
    ComboBox1.Items.Add(R.Name);
    while FindNext(R) = 0 do
      ComboBox1.Items.Add(R.Name);
  end;

  ComboBox1.ItemIndex:=0;
  }

end;

procedure TForm2.FormActivate(Sender: TObject);
var
  i,x,y:Integer;
  rad:Extended;
begin
  if FAtFirst then begin
    RePaint;

    Screen.CurSor:=crHourGlass;

    //ʉIuWFNg̐
    SG:=TSE.Create;

    //WCXeBbNIuWFNg̏
    Form1.DDIDEX1.Initialize;

    //e[u쐬
    For i:=0 to 1023 do begin
      rad:=i / 512.0 * Pi;
      FSinT[i]:=Sin(rad);
      FCosT[i]:=Cos(rad);
      SinT[i]:=Trunc(FSinT[i] * 1024.0);
      CosT[i]:=Trunc(FCosT[i] * 1024.0);
    end;

    //ɍWϊe[u
    for y:=0 to MAX_LOGOY do begin
      for x:=0 to MAX_LOGOX do begin
        PolarT[y,x].Y:=Trunc( Sqrt(Sqrt((Sqr(x-HALF_LOGOX)+Sqr(y-HALF_LOGOY)) / (HALF_LOGOY*HALF_LOGOY+HALF_LOGOX*HALF_LOGOX)))  * SIZE_LOGOTEX);
        if (y=HALF_LOGOY) then
          PolarT[y,x].X:=PolarT[y-1,x].X
        else
          PolarT[y,x].X:=Trunc( ( ArcTan((x-HALF_LOGOX)/((y-HALF_LOGOY)/1.6)) + 0.5*Pi ) / Pi * SIZE_LOGOTEX);
      end;
    end;

    Screen.CurSor:=CrDefault;

    //{^Enable
    BitBtn1.Enabled:=True;

    //݂̃rbgfvX16ȂȂAWindow{^
    if Form1.DDDD1.BitDepth = 16 then
      BitBtn2.Enabled:=True;

    FAtFirst:=False;
  end;
end;

//vCf[^̃[h
procedure TForm2.ComboBox1Change(Sender: TObject);
var
  fs:TFileStream;
begin

{
  if ComboBox1.ItemIndex <= 0 then
    REPLAY:=False
  else begin
    try
      fs:=TFileStream.Create(REPLAYPATH + ComboBox1.Items[ComboBox1.ItemIndex],fmOpenRead);
      fs.Read(ReplayData,Sizeof(ReplayData));
      fs.Free;
    except
      ComboBox1.ItemIndex:=0;
      REPLAY:=False;
      Exit;
    end;
    REPLAY:=True;
  end;
  }
end;

end.
